/*******************************************************************************
* File Name: PLC_UART_SPI_UART_PVT.h
* Version 1.20
*
* Description:
*  This private file provides constants and parameter values for the
*  SCB Component in SPI and UART modes.
*  Please do not use this file or its content in your project.
*
* Note:
*
********************************************************************************
* Copyright 2013-2014, Cypress Semiconductor Corporation. All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SCB_SPI_UART_PVT_PLC_UART_H)
#define CY_SCB_SPI_UART_PVT_PLC_UART_H

#include "PLC_UART_SPI_UART.h"


/***************************************
*     Internal Global Vars
***************************************/

#if(PLC_UART_INTERNAL_RX_SW_BUFFER_CONST)
    extern volatile uint32  PLC_UART_rxBufferHead;
    extern volatile uint32  PLC_UART_rxBufferTail;
    extern volatile uint8   PLC_UART_rxBufferOverflow;
#endif /* (PLC_UART_INTERNAL_RX_SW_BUFFER_CONST) */

#if(PLC_UART_INTERNAL_TX_SW_BUFFER_CONST)
    extern volatile uint32  PLC_UART_txBufferHead;
    extern volatile uint32  PLC_UART_txBufferTail;
#endif /* (PLC_UART_INTERNAL_TX_SW_BUFFER_CONST) */

#if(PLC_UART_INTERNAL_RX_SW_BUFFER)
    extern volatile uint8 PLC_UART_rxBufferInternal[PLC_UART_RX_BUFFER_SIZE];
#endif /* (PLC_UART_INTERNAL_RX_SW_BUFFER) */

#if(PLC_UART_INTERNAL_TX_SW_BUFFER)
    extern volatile uint8 PLC_UART_txBufferInternal[PLC_UART_TX_BUFFER_SIZE];
#endif /* (PLC_UART_INTERNAL_TX_SW_BUFFER) */


/***************************************
*     Private Function Prototypes
***************************************/

#if(PLC_UART_SCB_MODE_SPI_CONST_CFG)
    void PLC_UART_SpiInit(void);
#endif /* (PLC_UART_SCB_MODE_SPI_CONST_CFG) */

#if(PLC_UART_SPI_WAKE_ENABLE_CONST)
    void PLC_UART_SpiSaveConfig(void);
    void PLC_UART_SpiRestoreConfig(void);
#endif /* (PLC_UART_SPI_WAKE_ENABLE_CONST) */

#if(PLC_UART_SCB_MODE_UART_CONST_CFG)
    void PLC_UART_UartInit(void);
#endif /* (PLC_UART_SCB_MODE_UART_CONST_CFG) */

#if(PLC_UART_UART_WAKE_ENABLE_CONST)
    void PLC_UART_UartSaveConfig(void);
    void PLC_UART_UartRestoreConfig(void);
#endif /* (PLC_UART_UART_WAKE_ENABLE_CONST) */

/* Interrupt processing */
#define PLC_UART_SpiUartEnableIntRx(intSourceMask)  PLC_UART_SetRxInterruptMode(intSourceMask)
#define PLC_UART_SpiUartEnableIntTx(intSourceMask)  PLC_UART_SetTxInterruptMode(intSourceMask)
uint32  PLC_UART_SpiUartDisableIntRx(void);
uint32  PLC_UART_SpiUartDisableIntTx(void);

#endif /* (CY_SCB_SPI_UART_PVT_PLC_UART_H) */


/* [] END OF FILE */
