/*******************************************************************************
* File Name: RegEnable.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_RegEnable_H) /* Pins RegEnable_H */
#define CY_PINS_RegEnable_H

#include "cytypes.h"
#include "cyfitter.h"
#include "RegEnable_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    RegEnable_Write(uint8 value) ;
void    RegEnable_SetDriveMode(uint8 mode) ;
uint8   RegEnable_ReadDataReg(void) ;
uint8   RegEnable_Read(void) ;
uint8   RegEnable_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define RegEnable_DRIVE_MODE_BITS        (3)
#define RegEnable_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - RegEnable_DRIVE_MODE_BITS))
#define RegEnable_DRIVE_MODE_SHIFT       (0x00u)
#define RegEnable_DRIVE_MODE_MASK        (0x07u << RegEnable_DRIVE_MODE_SHIFT)

#define RegEnable_DM_ALG_HIZ         (0x00u << RegEnable_DRIVE_MODE_SHIFT)
#define RegEnable_DM_DIG_HIZ         (0x01u << RegEnable_DRIVE_MODE_SHIFT)
#define RegEnable_DM_RES_UP          (0x02u << RegEnable_DRIVE_MODE_SHIFT)
#define RegEnable_DM_RES_DWN         (0x03u << RegEnable_DRIVE_MODE_SHIFT)
#define RegEnable_DM_OD_LO           (0x04u << RegEnable_DRIVE_MODE_SHIFT)
#define RegEnable_DM_OD_HI           (0x05u << RegEnable_DRIVE_MODE_SHIFT)
#define RegEnable_DM_STRONG          (0x06u << RegEnable_DRIVE_MODE_SHIFT)
#define RegEnable_DM_RES_UPDWN       (0x07u << RegEnable_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define RegEnable_MASK               RegEnable__MASK
#define RegEnable_SHIFT              RegEnable__SHIFT
#define RegEnable_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define RegEnable_PS                     (* (reg32 *) RegEnable__PS)
/* Port Configuration */
#define RegEnable_PC                     (* (reg32 *) RegEnable__PC)
/* Data Register */
#define RegEnable_DR                     (* (reg32 *) RegEnable__DR)
/* Input Buffer Disable Override */
#define RegEnable_INP_DIS                (* (reg32 *) RegEnable__PC2)


#if defined(RegEnable__INTSTAT)  /* Interrupt Registers */

    #define RegEnable_INTSTAT                (* (reg32 *) RegEnable__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins RegEnable_H */


/* [] END OF FILE */
