/*******************************************************************************
* File Name: AN_Ce.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_AN_Ce_H) /* Pins AN_Ce_H */
#define CY_PINS_AN_Ce_H

#include "cytypes.h"
#include "cyfitter.h"
#include "AN_Ce_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    AN_Ce_Write(uint8 value) ;
void    AN_Ce_SetDriveMode(uint8 mode) ;
uint8   AN_Ce_ReadDataReg(void) ;
uint8   AN_Ce_Read(void) ;
uint8   AN_Ce_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define AN_Ce_DRIVE_MODE_BITS        (3)
#define AN_Ce_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - AN_Ce_DRIVE_MODE_BITS))

#define AN_Ce_DM_ALG_HIZ         (0x00u)
#define AN_Ce_DM_DIG_HIZ         (0x01u)
#define AN_Ce_DM_RES_UP          (0x02u)
#define AN_Ce_DM_RES_DWN         (0x03u)
#define AN_Ce_DM_OD_LO           (0x04u)
#define AN_Ce_DM_OD_HI           (0x05u)
#define AN_Ce_DM_STRONG          (0x06u)
#define AN_Ce_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define AN_Ce_MASK               AN_Ce__MASK
#define AN_Ce_SHIFT              AN_Ce__SHIFT
#define AN_Ce_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define AN_Ce_PS                     (* (reg32 *) AN_Ce__PS)
/* Port Configuration */
#define AN_Ce_PC                     (* (reg32 *) AN_Ce__PC)
/* Data Register */
#define AN_Ce_DR                     (* (reg32 *) AN_Ce__DR)
/* Input Buffer Disable Override */
#define AN_Ce_INP_DIS                (* (reg32 *) AN_Ce__PC2)


#if defined(AN_Ce__INTSTAT)  /* Interrupt Registers */

    #define AN_Ce_INTSTAT                (* (reg32 *) AN_Ce__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define AN_Ce_DRIVE_MODE_SHIFT       (0x00u)
#define AN_Ce_DRIVE_MODE_MASK        (0x07u << AN_Ce_DRIVE_MODE_SHIFT)


#endif /* End Pins AN_Ce_H */


/* [] END OF FILE */
