/*******************************************************************************
* File Name: AN_pH.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_AN_pH_H) /* Pins AN_pH_H */
#define CY_PINS_AN_pH_H

#include "cytypes.h"
#include "cyfitter.h"
#include "AN_pH_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    AN_pH_Write(uint8 value) ;
void    AN_pH_SetDriveMode(uint8 mode) ;
uint8   AN_pH_ReadDataReg(void) ;
uint8   AN_pH_Read(void) ;
uint8   AN_pH_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define AN_pH_DRIVE_MODE_BITS        (3)
#define AN_pH_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - AN_pH_DRIVE_MODE_BITS))

#define AN_pH_DM_ALG_HIZ         (0x00u)
#define AN_pH_DM_DIG_HIZ         (0x01u)
#define AN_pH_DM_RES_UP          (0x02u)
#define AN_pH_DM_RES_DWN         (0x03u)
#define AN_pH_DM_OD_LO           (0x04u)
#define AN_pH_DM_OD_HI           (0x05u)
#define AN_pH_DM_STRONG          (0x06u)
#define AN_pH_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define AN_pH_MASK               AN_pH__MASK
#define AN_pH_SHIFT              AN_pH__SHIFT
#define AN_pH_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define AN_pH_PS                     (* (reg32 *) AN_pH__PS)
/* Port Configuration */
#define AN_pH_PC                     (* (reg32 *) AN_pH__PC)
/* Data Register */
#define AN_pH_DR                     (* (reg32 *) AN_pH__DR)
/* Input Buffer Disable Override */
#define AN_pH_INP_DIS                (* (reg32 *) AN_pH__PC2)


#if defined(AN_pH__INTSTAT)  /* Interrupt Registers */

    #define AN_pH_INTSTAT                (* (reg32 *) AN_pH__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define AN_pH_DRIVE_MODE_SHIFT       (0x00u)
#define AN_pH_DRIVE_MODE_MASK        (0x07u << AN_pH_DRIVE_MODE_SHIFT)


#endif /* End Pins AN_pH_H */


/* [] END OF FILE */
