/*******************************************************************************
* File Name: GreenLed.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_GreenLed_H) /* Pins GreenLed_H */
#define CY_PINS_GreenLed_H

#include "cytypes.h"
#include "cyfitter.h"
#include "GreenLed_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    GreenLed_Write(uint8 value) ;
void    GreenLed_SetDriveMode(uint8 mode) ;
uint8   GreenLed_ReadDataReg(void) ;
uint8   GreenLed_Read(void) ;
uint8   GreenLed_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define GreenLed_DRIVE_MODE_BITS        (3)
#define GreenLed_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - GreenLed_DRIVE_MODE_BITS))

#define GreenLed_DM_ALG_HIZ         (0x00u)
#define GreenLed_DM_DIG_HIZ         (0x01u)
#define GreenLed_DM_RES_UP          (0x02u)
#define GreenLed_DM_RES_DWN         (0x03u)
#define GreenLed_DM_OD_LO           (0x04u)
#define GreenLed_DM_OD_HI           (0x05u)
#define GreenLed_DM_STRONG          (0x06u)
#define GreenLed_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define GreenLed_MASK               GreenLed__MASK
#define GreenLed_SHIFT              GreenLed__SHIFT
#define GreenLed_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define GreenLed_PS                     (* (reg32 *) GreenLed__PS)
/* Port Configuration */
#define GreenLed_PC                     (* (reg32 *) GreenLed__PC)
/* Data Register */
#define GreenLed_DR                     (* (reg32 *) GreenLed__DR)
/* Input Buffer Disable Override */
#define GreenLed_INP_DIS                (* (reg32 *) GreenLed__PC2)


#if defined(GreenLed__INTSTAT)  /* Interrupt Registers */

    #define GreenLed_INTSTAT                (* (reg32 *) GreenLed__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define GreenLed_DRIVE_MODE_SHIFT       (0x00u)
#define GreenLed_DRIVE_MODE_MASK        (0x07u << GreenLed_DRIVE_MODE_SHIFT)


#endif /* End Pins GreenLed_H */


/* [] END OF FILE */
