/*******************************************************************************
* File Name: PC_COM_UART_SPI_UART_PVT.h
* Version 1.20
*
* Description:
*  This private file provides constants and parameter values for the
*  SCB Component in SPI and UART modes.
*  Please do not use this file or its content in your project.
*
* Note:
*
********************************************************************************
* Copyright 2013-2014, Cypress Semiconductor Corporation. All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SCB_SPI_UART_PVT_PC_COM_UART_H)
#define CY_SCB_SPI_UART_PVT_PC_COM_UART_H

#include "PC_COM_UART_SPI_UART.h"


/***************************************
*     Internal Global Vars
***************************************/

#if(PC_COM_UART_INTERNAL_RX_SW_BUFFER_CONST)
    extern volatile uint32  PC_COM_UART_rxBufferHead;
    extern volatile uint32  PC_COM_UART_rxBufferTail;
    extern volatile uint8   PC_COM_UART_rxBufferOverflow;
#endif /* (PC_COM_UART_INTERNAL_RX_SW_BUFFER_CONST) */

#if(PC_COM_UART_INTERNAL_TX_SW_BUFFER_CONST)
    extern volatile uint32  PC_COM_UART_txBufferHead;
    extern volatile uint32  PC_COM_UART_txBufferTail;
#endif /* (PC_COM_UART_INTERNAL_TX_SW_BUFFER_CONST) */

#if(PC_COM_UART_INTERNAL_RX_SW_BUFFER)
    extern volatile uint8 PC_COM_UART_rxBufferInternal[PC_COM_UART_RX_BUFFER_SIZE];
#endif /* (PC_COM_UART_INTERNAL_RX_SW_BUFFER) */

#if(PC_COM_UART_INTERNAL_TX_SW_BUFFER)
    extern volatile uint8 PC_COM_UART_txBufferInternal[PC_COM_UART_TX_BUFFER_SIZE];
#endif /* (PC_COM_UART_INTERNAL_TX_SW_BUFFER) */


/***************************************
*     Private Function Prototypes
***************************************/

#if(PC_COM_UART_SCB_MODE_SPI_CONST_CFG)
    void PC_COM_UART_SpiInit(void);
#endif /* (PC_COM_UART_SCB_MODE_SPI_CONST_CFG) */

#if(PC_COM_UART_SPI_WAKE_ENABLE_CONST)
    void PC_COM_UART_SpiSaveConfig(void);
    void PC_COM_UART_SpiRestoreConfig(void);
#endif /* (PC_COM_UART_SPI_WAKE_ENABLE_CONST) */

#if(PC_COM_UART_SCB_MODE_UART_CONST_CFG)
    void PC_COM_UART_UartInit(void);
#endif /* (PC_COM_UART_SCB_MODE_UART_CONST_CFG) */

#if(PC_COM_UART_UART_WAKE_ENABLE_CONST)
    void PC_COM_UART_UartSaveConfig(void);
    void PC_COM_UART_UartRestoreConfig(void);
#endif /* (PC_COM_UART_UART_WAKE_ENABLE_CONST) */

/* Interrupt processing */
#define PC_COM_UART_SpiUartEnableIntRx(intSourceMask)  PC_COM_UART_SetRxInterruptMode(intSourceMask)
#define PC_COM_UART_SpiUartEnableIntTx(intSourceMask)  PC_COM_UART_SetTxInterruptMode(intSourceMask)
uint32  PC_COM_UART_SpiUartDisableIntRx(void);
uint32  PC_COM_UART_SpiUartDisableIntTx(void);

#endif /* (CY_SCB_SPI_UART_PVT_PC_COM_UART_H) */


/* [] END OF FILE */
