/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "main.h"

int main()
{
    XBEERXOK = 0;
    XBEETXOK = 0;
    PLCRXOK = 0;
    PLCTXOK = 0;
    PLCINTCLK = 0;
    CBOOT = 0;
    sys_init();
    
    for(;;)
    {
        if(XBEERXOK)
        {
            XBEE_UART_DisableInt();
            PLC_UART_Start();
            CyDelay(1);
            PLC_UART_UartPutString(XBeeRXbuffer);
            XBEERXOK = 0;
            PLCPacketHandler();
            //if( CBOOT < 5)
            //    ++CBOOT;
        }
        if(PLCRXOK)
        {
            strcpy(XBeeTXbuffer, PLCRXbuffer);
            CyDelayUs(50);
            XBeeSendPacket(); //Envia frame al XB
            PLCRXOK = 0;
            XBEE_UART_EnableInt();
            PLC_UART_Stop();
        }
        if(PLCINTCLK)
        {
            PLCINTCLK = 0;
            PLCRXOK = 0;
            XBEERXOK = 0;
            XBEE_UART_EnableInt();
        }
        /*if( CBOOT == 5)
        {
            CBOOT = 0;
            CySoftwareReset();
        }*/
    }
}

void sys_init(void)
{
	XBEE_UART_Start();
    
    CyDelayUs(50);
    
    XBEE_UART_SetCustomInterruptHandler(&XBeePacketHandler);
    
    isr_PLCTimer_StartEx(IntPLCTimer);
    PLCTimer_Init();
    
    init_adc();
            
	CyGlobalIntEnable;
}

void XBeePacketHandler(void)
{
    uint8 tempchar=0, checksum=0, rfchecksum=0, api_id=0, xbee_checksum=0;
    int i=0, j=0, k=0;
    uint16 length=0;
	/* Check interrupt source*/
	if(XBEE_UART_INTR_CAUSE_RX & XBEE_UART_GetInterruptCause())
	{	
        //HEADER
        while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
            CyDelayUs(10);
        tempchar = XBEE_UART_UartGetChar(); // toma el dato del xbee
        if( tempchar == 0x7E ) // compara el dato empieza con la cabecera del xbee 7E
        {
            CyDelayUs(10);
            while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                CyDelayUs(10);
            tempchar = XBEE_UART_UartGetChar();
            
            //LENGTH
            length = (length | tempchar) << 8; //hace una or con tempchar y lenght y lo recorre 8 lugares
            while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                CyDelayUs(10);
            tempchar = XBEE_UART_UartGetChar();
            length = length | tempchar;
            
            //API ID
            while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                CyDelayUs(10);
            tempchar = XBEE_UART_UartGetChar();
            api_id = tempchar;
            checksum = checksum+tempchar;

            if(api_id == 0x80)
            {
                //MSB ADDRESS (Most Significant Byte)
                for(i=3; i >= 0; i--)
                {       
                    while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                        CyDelayUs(10);
                    tempchar = XBEE_UART_UartGetChar();
                    if( tempchar == 0x7D )
                    {
                        while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                            CyDelayUs(10);
                        tempchar = XBEE_UART_UartGetChar();
                        tempchar = tempchar^0x20;
                        checksum = checksum+tempchar;
                    }
                    else
                        checksum = checksum+tempchar;
                }
                
                //LSB ADDRESS (Least Significant Byte)
                for(i=3; i >= 0; i--)
                {    
                    while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                        CyDelayUs(10);
                    tempchar = XBEE_UART_UartGetChar();
                    if( tempchar == 0x7D )
                    {
                        
                        while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                            CyDelayUs(10);
                        tempchar = XBEE_UART_UartGetChar();
                        tempchar = tempchar^0x20;
                        checksum = checksum+tempchar;
                    }
                    else
                        checksum = checksum+tempchar;
                }
                
                //RSSI
                while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                    CyDelayUs(10);
                tempchar = XBEE_UART_UartGetChar();
                if( tempchar == 0x7D )
                {
                    
                    while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                        CyDelayUs(10);
                    tempchar = XBEE_UART_UartGetChar();
                    tempchar = tempchar^0x20;
                    checksum = checksum+tempchar;
                }
                else
                    checksum = checksum+tempchar;
                rssi = tempchar;
                
                //BROADCAST
                while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                    CyDelayUs(10);
                tempchar = XBEE_UART_UartGetChar();
                if( tempchar == 0x7D )
                {
                    while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                        CyDelayUs(10);
                    tempchar = XBEE_UART_UartGetChar();
                    tempchar = tempchar^0x20;
                    checksum = checksum+tempchar;
                }
                else
                    checksum = checksum+tempchar;
                broadcast = 0x0F & tempchar;
                
                //*************
                // DATA
                //*************
                k = length - 11;
                //PLC Identifier Header
                for(i=0; i < k; i++)
                {
                    while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                    CyDelayUs(10);
                    tempchar = XBEE_UART_UartGetChar();
                    if( tempchar == 0x7D )
                    {
                        
                        while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                            CyDelayUs(10);
                        tempchar = XBEE_UART_UartGetChar();
                        tempchar = tempchar^0x20;
                        checksum = checksum+tempchar;
                    }
                    else
                        checksum = checksum+tempchar;
                    XBeeRXbuffer[i] = tempchar;
                }
                if(XBeeRXbuffer[0] == PLCHEADER && XBeeRXbuffer[k-1] == PLCTAIL )
                    XBEERXOK = 1;
                XBeeRXbuffer[k] = '\0';
                //++++++++++++++++++++++++++++++++++++++++++++++++++
                
                while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
                    CyDelayUs(10);
                tempchar = XBEE_UART_UartGetChar();
                
                rfchecksum = tempchar;
                checksum = 0xFF - checksum;      
                
                if( rfchecksum != checksum)
                {
                    blink_yellowleds(1);
                    XBEERXOK = 0;
                }
                else
                {
                    if(XBEERXOK)
                        blink_greenleds(1);
                    else
                        blink_redleds(1);
                }
            }
            //if(api_id == 0x89)
            //    tx_status(checksum);
        }
        CyDelay(1);
        XBEE_UART_ClearRxInterruptSource(XBEE_UART_INTR_RX_NOT_EMPTY);
    }
    
}


void PLCPacketHandler()
{
    uint8 tempchar;
    int i=0, j=0;
    
    if(!PLCINTCLK)
    {
        isr_PLCTimer_StartEx(&IntPLCTimer);
        PLCTimer_Init();
        PLCTimer_Start();
        
        do
        {
            while(PLC_UART_SpiUartGetRxBufferSize() == 0)
            {
                if(j > 2000)
                    PLCINTCLK = 1;
                if(PLCINTCLK)
                    return;
                CyDelayUs(10);
                j++;
            }
            tempchar = PLC_UART_UartGetChar(); // toma el dato del PLC
        } while(tempchar != 0x02);
        PLCRXbuffer[i] = tempchar;
        i++;
        j=0;
        do
        {
            while(PLC_UART_SpiUartGetRxBufferSize() == 0)
            {
                if(j > 2000)
                    PLCINTCLK = 1;
                if(PLCINTCLK)
                    return;
                CyDelayUs(10);
                j++;
            }
            tempchar = PLC_UART_UartGetChar(); // toma el dato del PLC
            PLCRXbuffer[i] = tempchar;
            i++;
            j=0;
        } while(tempchar != 0x03 && i < 99);
        
        if(tempchar == 0x03)
        {
            PLCTimer_Stop();
            PLCRXbuffer[i] = '\0';
            PLCRXOK = 1;
            blink_greenleds(2);
        }
        else
        {
            PLCTimer_Stop();
            PLCINTCLK = 1;
            blink_redleds(2);
        }
        
        return;
    }
    else
        return;
}

void IntPLCTimer(void)
{
    if( PLCTimer_GetInterruptSource() && PLCTimer_INTR_MASK_TC)
    {
        blink_yellowleds(3);
        isr_PLCTimer_ClearPending();
        PLCTimer_ClearInterrupt(PLCTimer_INTR_MASK_TC);
    }
    else
    {
        PLCTimer_ClearInterrupt(PLCTimer_INTR_MASK_CC_MATCH);
    }
}

void tx_status(uint8 checksum)
{
    uint8 frameid, status, rfchecksum;
    
    while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
            CyDelayUs(10);
    frameid = XBEE_UART_UartGetChar();
    checksum = checksum+frameid;
    
    while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
            CyDelayUs(10);
    status = XBEE_UART_UartGetChar();
    checksum = checksum+status;
    
    checksum = 0xFF - checksum;
    while(XBEE_UART_SpiUartGetRxBufferSize() == 0)
            CyDelayUs(10);
    rfchecksum = XBEE_UART_UartGetChar();
    
    if( rfchecksum == checksum)
    {
        XBEETXSTATUS = status;
    }
}


int XBeeSendPacket()
{  
   uint8 *frame, *scaped_frame;
   int i, k; //variables enteras 
   uint8 checksumxbee, length_data, frame_size; //se declan mas variables para formar la trama del xbee
   
   length_data = checksumxbee = 0;
   
   length_data = strlen(XBeeTXbuffer); //strlen mide la cantidad de caracteres de DATA que sera igual a 5
   frame_size = 15 + length_data + 3; //se le suma el lenght_data para calcular el tamaño del frame , 15 deconfiguracion +´5 de datos
   frame = (uint8*) malloc(sizeof(uint8)*frame_size);// RESERVAR LA MEMORIA DINAMICA
   
   //Frame init, Bite 1//
   frame[0] = xbee_settings[0];
   
   //Frame length Byte 2-3//
   frame[1] = 0x00;
   frame[2] = frame_size - 4; // MENOS CABECERA , 2 DE TAMAÑO DE PAQUETE Y CHEKSUN
   
   //ApiFrame,Byte 4//
   frame[3] = xbee_settings[1];
   checksumxbee += xbee_settings[1];
   
   //Frame ID for Response//
   frame[4] = xbee_settings[2]; 
   checksumxbee += xbee_settings[2];
   
   //Destination MAC Address//
   for(i = 5; i < 13; i++) //i igual a 5, el for se complira hata que llegue a 13
   {
      frame[i] = broadcastAddress[i-5];
      checksumxbee += broadcastAddress[i-5];
   }
   
   //Setting options
   frame[13] = xbee_settings[3];
   checksumxbee += xbee_settings[3];
   
   frame[14] = '<';
   checksumxbee += '<';
   frame[15] = '+';
   checksumxbee += '+';
   frame[16] = '>';
   checksumxbee += '>';
   //**Data**//
   for(i=17; i < 17+length_data; i++)
   {
      frame[i] = XBeeTXbuffer[i-17];
      checksumxbee += XBeeTXbuffer[i-17];
   }
   
   //****//x
   
   checksumxbee = 0xFF - checksumxbee;
   
   frame[17 + length_data] = checksumxbee;
   
   scaped_frame = scape_frame(frame, &frame_size);
   
   if (scaped_frame != 0 )
   {
      free(frame);
      frame = scaped_frame;
   }

   for(k = 0; k < frame_size; k++)
   {
      XBEE_UART_UartPutChar(frame[k]);
      CyDelayUs(50);
   }
   free(frame);
   blink_greenleds(3);
   
   return 0;
}

uint8* scape_frame(uint8 *frame, uint8 *length)
{
   int count = 0, i , j;
   uint8 *escaped_frame;
   
   for (i=3; i < *length-1; i++)
   {
      if (frame[i] == ESCAPE1 || frame[i] == ESCAPE2 || frame[i] == ESCAPE3 || frame[i] == ESCAPE4) // se le hace una or a cada escape del frame
         ++count;
   }
   
   if (count > 0)
   {
      escaped_frame = (uint8*)malloc (sizeof(char)*(*length + count));
      escaped_frame[0] = frame[0];
      escaped_frame[1] = frame[1];
      escaped_frame[2] = frame[2];
      
      for(i=3, j=3; i < *length-1; i++, j++)
      {
         if( frame[i] == ESCAPE1 || frame[i] == ESCAPE2 || frame[i] == ESCAPE3 || frame[i] == ESCAPE4 )
         {
            escaped_frame[j] = 0x7D;
            ++j;
            escaped_frame[j] = frame[i]^0x20;
         }
         else
            escaped_frame[j] = frame[i];
      }
       escaped_frame[j] = frame[i];
      *length = *length+count;
      }
      if( !count )
         return 0;
      else
         return escaped_frame;

}