/*******************************************************************************
* File Name: An1.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_An1_H) /* Pins An1_H */
#define CY_PINS_An1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "An1_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    An1_Write(uint8 value) ;
void    An1_SetDriveMode(uint8 mode) ;
uint8   An1_ReadDataReg(void) ;
uint8   An1_Read(void) ;
uint8   An1_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define An1_DRIVE_MODE_BITS        (3)
#define An1_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - An1_DRIVE_MODE_BITS))

#define An1_DM_ALG_HIZ         (0x00u)
#define An1_DM_DIG_HIZ         (0x01u)
#define An1_DM_RES_UP          (0x02u)
#define An1_DM_RES_DWN         (0x03u)
#define An1_DM_OD_LO           (0x04u)
#define An1_DM_OD_HI           (0x05u)
#define An1_DM_STRONG          (0x06u)
#define An1_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define An1_MASK               An1__MASK
#define An1_SHIFT              An1__SHIFT
#define An1_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define An1_PS                     (* (reg32 *) An1__PS)
/* Port Configuration */
#define An1_PC                     (* (reg32 *) An1__PC)
/* Data Register */
#define An1_DR                     (* (reg32 *) An1__DR)
/* Input Buffer Disable Override */
#define An1_INP_DIS                (* (reg32 *) An1__PC2)


#if defined(An1__INTSTAT)  /* Interrupt Registers */

    #define An1_INTSTAT                (* (reg32 *) An1__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define An1_DRIVE_MODE_SHIFT       (0x00u)
#define An1_DRIVE_MODE_MASK        (0x07u << An1_DRIVE_MODE_SHIFT)


#endif /* End Pins An1_H */


/* [] END OF FILE */
