/*******************************************************************************
* File Name: An5.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_An5_H) /* Pins An5_H */
#define CY_PINS_An5_H

#include "cytypes.h"
#include "cyfitter.h"
#include "An5_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    An5_Write(uint8 value) ;
void    An5_SetDriveMode(uint8 mode) ;
uint8   An5_ReadDataReg(void) ;
uint8   An5_Read(void) ;
uint8   An5_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define An5_DRIVE_MODE_BITS        (3)
#define An5_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - An5_DRIVE_MODE_BITS))

#define An5_DM_ALG_HIZ         (0x00u)
#define An5_DM_DIG_HIZ         (0x01u)
#define An5_DM_RES_UP          (0x02u)
#define An5_DM_RES_DWN         (0x03u)
#define An5_DM_OD_LO           (0x04u)
#define An5_DM_OD_HI           (0x05u)
#define An5_DM_STRONG          (0x06u)
#define An5_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define An5_MASK               An5__MASK
#define An5_SHIFT              An5__SHIFT
#define An5_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define An5_PS                     (* (reg32 *) An5__PS)
/* Port Configuration */
#define An5_PC                     (* (reg32 *) An5__PC)
/* Data Register */
#define An5_DR                     (* (reg32 *) An5__DR)
/* Input Buffer Disable Override */
#define An5_INP_DIS                (* (reg32 *) An5__PC2)


#if defined(An5__INTSTAT)  /* Interrupt Registers */

    #define An5_INTSTAT                (* (reg32 *) An5__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define An5_DRIVE_MODE_SHIFT       (0x00u)
#define An5_DRIVE_MODE_MASK        (0x07u << An5_DRIVE_MODE_SHIFT)


#endif /* End Pins An5_H */


/* [] END OF FILE */
