/*******************************************************************************
* File Name: DipSW1.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_DipSW1_H) /* Pins DipSW1_H */
#define CY_PINS_DipSW1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "DipSW1_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    DipSW1_Write(uint8 value) ;
void    DipSW1_SetDriveMode(uint8 mode) ;
uint8   DipSW1_ReadDataReg(void) ;
uint8   DipSW1_Read(void) ;
uint8   DipSW1_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define DipSW1_DRIVE_MODE_BITS        (3)
#define DipSW1_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - DipSW1_DRIVE_MODE_BITS))

#define DipSW1_DM_ALG_HIZ         (0x00u)
#define DipSW1_DM_DIG_HIZ         (0x01u)
#define DipSW1_DM_RES_UP          (0x02u)
#define DipSW1_DM_RES_DWN         (0x03u)
#define DipSW1_DM_OD_LO           (0x04u)
#define DipSW1_DM_OD_HI           (0x05u)
#define DipSW1_DM_STRONG          (0x06u)
#define DipSW1_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define DipSW1_MASK               DipSW1__MASK
#define DipSW1_SHIFT              DipSW1__SHIFT
#define DipSW1_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define DipSW1_PS                     (* (reg32 *) DipSW1__PS)
/* Port Configuration */
#define DipSW1_PC                     (* (reg32 *) DipSW1__PC)
/* Data Register */
#define DipSW1_DR                     (* (reg32 *) DipSW1__DR)
/* Input Buffer Disable Override */
#define DipSW1_INP_DIS                (* (reg32 *) DipSW1__PC2)


#if defined(DipSW1__INTSTAT)  /* Interrupt Registers */

    #define DipSW1_INTSTAT                (* (reg32 *) DipSW1__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define DipSW1_DRIVE_MODE_SHIFT       (0x00u)
#define DipSW1_DRIVE_MODE_MASK        (0x07u << DipSW1_DRIVE_MODE_SHIFT)


#endif /* End Pins DipSW1_H */


/* [] END OF FILE */
