/*******************************************************************************
* File Name: DipSW2.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_DipSW2_H) /* Pins DipSW2_H */
#define CY_PINS_DipSW2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "DipSW2_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    DipSW2_Write(uint8 value) ;
void    DipSW2_SetDriveMode(uint8 mode) ;
uint8   DipSW2_ReadDataReg(void) ;
uint8   DipSW2_Read(void) ;
uint8   DipSW2_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define DipSW2_DRIVE_MODE_BITS        (3)
#define DipSW2_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - DipSW2_DRIVE_MODE_BITS))

#define DipSW2_DM_ALG_HIZ         (0x00u)
#define DipSW2_DM_DIG_HIZ         (0x01u)
#define DipSW2_DM_RES_UP          (0x02u)
#define DipSW2_DM_RES_DWN         (0x03u)
#define DipSW2_DM_OD_LO           (0x04u)
#define DipSW2_DM_OD_HI           (0x05u)
#define DipSW2_DM_STRONG          (0x06u)
#define DipSW2_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define DipSW2_MASK               DipSW2__MASK
#define DipSW2_SHIFT              DipSW2__SHIFT
#define DipSW2_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define DipSW2_PS                     (* (reg32 *) DipSW2__PS)
/* Port Configuration */
#define DipSW2_PC                     (* (reg32 *) DipSW2__PC)
/* Data Register */
#define DipSW2_DR                     (* (reg32 *) DipSW2__DR)
/* Input Buffer Disable Override */
#define DipSW2_INP_DIS                (* (reg32 *) DipSW2__PC2)


#if defined(DipSW2__INTSTAT)  /* Interrupt Registers */

    #define DipSW2_INTSTAT                (* (reg32 *) DipSW2__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define DipSW2_DRIVE_MODE_SHIFT       (0x00u)
#define DipSW2_DRIVE_MODE_MASK        (0x07u << DipSW2_DRIVE_MODE_SHIFT)


#endif /* End Pins DipSW2_H */


/* [] END OF FILE */
