/*******************************************************************************
* File Name: DipSW3.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_DipSW3_H) /* Pins DipSW3_H */
#define CY_PINS_DipSW3_H

#include "cytypes.h"
#include "cyfitter.h"
#include "DipSW3_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    DipSW3_Write(uint8 value) ;
void    DipSW3_SetDriveMode(uint8 mode) ;
uint8   DipSW3_ReadDataReg(void) ;
uint8   DipSW3_Read(void) ;
uint8   DipSW3_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define DipSW3_DRIVE_MODE_BITS        (3)
#define DipSW3_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - DipSW3_DRIVE_MODE_BITS))

#define DipSW3_DM_ALG_HIZ         (0x00u)
#define DipSW3_DM_DIG_HIZ         (0x01u)
#define DipSW3_DM_RES_UP          (0x02u)
#define DipSW3_DM_RES_DWN         (0x03u)
#define DipSW3_DM_OD_LO           (0x04u)
#define DipSW3_DM_OD_HI           (0x05u)
#define DipSW3_DM_STRONG          (0x06u)
#define DipSW3_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define DipSW3_MASK               DipSW3__MASK
#define DipSW3_SHIFT              DipSW3__SHIFT
#define DipSW3_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define DipSW3_PS                     (* (reg32 *) DipSW3__PS)
/* Port Configuration */
#define DipSW3_PC                     (* (reg32 *) DipSW3__PC)
/* Data Register */
#define DipSW3_DR                     (* (reg32 *) DipSW3__DR)
/* Input Buffer Disable Override */
#define DipSW3_INP_DIS                (* (reg32 *) DipSW3__PC2)


#if defined(DipSW3__INTSTAT)  /* Interrupt Registers */

    #define DipSW3_INTSTAT                (* (reg32 *) DipSW3__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define DipSW3_DRIVE_MODE_SHIFT       (0x00u)
#define DipSW3_DRIVE_MODE_MASK        (0x07u << DipSW3_DRIVE_MODE_SHIFT)


#endif /* End Pins DipSW3_H */


/* [] END OF FILE */
