/*******************************************************************************
* File Name: DipSW4.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_DipSW4_H) /* Pins DipSW4_H */
#define CY_PINS_DipSW4_H

#include "cytypes.h"
#include "cyfitter.h"
#include "DipSW4_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    DipSW4_Write(uint8 value) ;
void    DipSW4_SetDriveMode(uint8 mode) ;
uint8   DipSW4_ReadDataReg(void) ;
uint8   DipSW4_Read(void) ;
uint8   DipSW4_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define DipSW4_DRIVE_MODE_BITS        (3)
#define DipSW4_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - DipSW4_DRIVE_MODE_BITS))

#define DipSW4_DM_ALG_HIZ         (0x00u)
#define DipSW4_DM_DIG_HIZ         (0x01u)
#define DipSW4_DM_RES_UP          (0x02u)
#define DipSW4_DM_RES_DWN         (0x03u)
#define DipSW4_DM_OD_LO           (0x04u)
#define DipSW4_DM_OD_HI           (0x05u)
#define DipSW4_DM_STRONG          (0x06u)
#define DipSW4_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define DipSW4_MASK               DipSW4__MASK
#define DipSW4_SHIFT              DipSW4__SHIFT
#define DipSW4_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define DipSW4_PS                     (* (reg32 *) DipSW4__PS)
/* Port Configuration */
#define DipSW4_PC                     (* (reg32 *) DipSW4__PC)
/* Data Register */
#define DipSW4_DR                     (* (reg32 *) DipSW4__DR)
/* Input Buffer Disable Override */
#define DipSW4_INP_DIS                (* (reg32 *) DipSW4__PC2)


#if defined(DipSW4__INTSTAT)  /* Interrupt Registers */

    #define DipSW4_INTSTAT                (* (reg32 *) DipSW4__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define DipSW4_DRIVE_MODE_SHIFT       (0x00u)
#define DipSW4_DRIVE_MODE_MASK        (0x07u << DipSW4_DRIVE_MODE_SHIFT)


#endif /* End Pins DipSW4_H */


/* [] END OF FILE */
