/*******************************************************************************
* File Name: IntLed.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_IntLed_H) /* Pins IntLed_H */
#define CY_PINS_IntLed_H

#include "cytypes.h"
#include "cyfitter.h"
#include "IntLed_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    IntLed_Write(uint8 value) ;
void    IntLed_SetDriveMode(uint8 mode) ;
uint8   IntLed_ReadDataReg(void) ;
uint8   IntLed_Read(void) ;
uint8   IntLed_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define IntLed_DRIVE_MODE_BITS        (3)
#define IntLed_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - IntLed_DRIVE_MODE_BITS))

#define IntLed_DM_ALG_HIZ         (0x00u)
#define IntLed_DM_DIG_HIZ         (0x01u)
#define IntLed_DM_RES_UP          (0x02u)
#define IntLed_DM_RES_DWN         (0x03u)
#define IntLed_DM_OD_LO           (0x04u)
#define IntLed_DM_OD_HI           (0x05u)
#define IntLed_DM_STRONG          (0x06u)
#define IntLed_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define IntLed_MASK               IntLed__MASK
#define IntLed_SHIFT              IntLed__SHIFT
#define IntLed_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define IntLed_PS                     (* (reg32 *) IntLed__PS)
/* Port Configuration */
#define IntLed_PC                     (* (reg32 *) IntLed__PC)
/* Data Register */
#define IntLed_DR                     (* (reg32 *) IntLed__DR)
/* Input Buffer Disable Override */
#define IntLed_INP_DIS                (* (reg32 *) IntLed__PC2)


#if defined(IntLed__INTSTAT)  /* Interrupt Registers */

    #define IntLed_INTSTAT                (* (reg32 *) IntLed__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define IntLed_DRIVE_MODE_SHIFT       (0x00u)
#define IntLed_DRIVE_MODE_MASK        (0x07u << IntLed_DRIVE_MODE_SHIFT)


#endif /* End Pins IntLed_H */


/* [] END OF FILE */
