/*******************************************************************************
* File Name: NA1.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_NA1_H) /* Pins NA1_H */
#define CY_PINS_NA1_H

#include "cytypes.h"
#include "cyfitter.h"
#include "NA1_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    NA1_Write(uint8 value) ;
void    NA1_SetDriveMode(uint8 mode) ;
uint8   NA1_ReadDataReg(void) ;
uint8   NA1_Read(void) ;
uint8   NA1_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define NA1_DRIVE_MODE_BITS        (3)
#define NA1_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - NA1_DRIVE_MODE_BITS))

#define NA1_DM_ALG_HIZ         (0x00u)
#define NA1_DM_DIG_HIZ         (0x01u)
#define NA1_DM_RES_UP          (0x02u)
#define NA1_DM_RES_DWN         (0x03u)
#define NA1_DM_OD_LO           (0x04u)
#define NA1_DM_OD_HI           (0x05u)
#define NA1_DM_STRONG          (0x06u)
#define NA1_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define NA1_MASK               NA1__MASK
#define NA1_SHIFT              NA1__SHIFT
#define NA1_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define NA1_PS                     (* (reg32 *) NA1__PS)
/* Port Configuration */
#define NA1_PC                     (* (reg32 *) NA1__PC)
/* Data Register */
#define NA1_DR                     (* (reg32 *) NA1__DR)
/* Input Buffer Disable Override */
#define NA1_INP_DIS                (* (reg32 *) NA1__PC2)


#if defined(NA1__INTSTAT)  /* Interrupt Registers */

    #define NA1_INTSTAT                (* (reg32 *) NA1__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define NA1_DRIVE_MODE_SHIFT       (0x00u)
#define NA1_DRIVE_MODE_MASK        (0x07u << NA1_DRIVE_MODE_SHIFT)


#endif /* End Pins NA1_H */


/* [] END OF FILE */
