/*******************************************************************************
* File Name: NA2.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_NA2_H) /* Pins NA2_H */
#define CY_PINS_NA2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "NA2_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    NA2_Write(uint8 value) ;
void    NA2_SetDriveMode(uint8 mode) ;
uint8   NA2_ReadDataReg(void) ;
uint8   NA2_Read(void) ;
uint8   NA2_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define NA2_DRIVE_MODE_BITS        (3)
#define NA2_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - NA2_DRIVE_MODE_BITS))

#define NA2_DM_ALG_HIZ         (0x00u)
#define NA2_DM_DIG_HIZ         (0x01u)
#define NA2_DM_RES_UP          (0x02u)
#define NA2_DM_RES_DWN         (0x03u)
#define NA2_DM_OD_LO           (0x04u)
#define NA2_DM_OD_HI           (0x05u)
#define NA2_DM_STRONG          (0x06u)
#define NA2_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define NA2_MASK               NA2__MASK
#define NA2_SHIFT              NA2__SHIFT
#define NA2_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define NA2_PS                     (* (reg32 *) NA2__PS)
/* Port Configuration */
#define NA2_PC                     (* (reg32 *) NA2__PC)
/* Data Register */
#define NA2_DR                     (* (reg32 *) NA2__DR)
/* Input Buffer Disable Override */
#define NA2_INP_DIS                (* (reg32 *) NA2__PC2)


#if defined(NA2__INTSTAT)  /* Interrupt Registers */

    #define NA2_INTSTAT                (* (reg32 *) NA2__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define NA2_DRIVE_MODE_SHIFT       (0x00u)
#define NA2_DRIVE_MODE_MASK        (0x07u << NA2_DRIVE_MODE_SHIFT)


#endif /* End Pins NA2_H */


/* [] END OF FILE */
