/*******************************************************************************
* File Name: Opto.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Opto_H) /* Pins Opto_H */
#define CY_PINS_Opto_H

#include "cytypes.h"
#include "cyfitter.h"
#include "Opto_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Opto_Write(uint8 value) ;
void    Opto_SetDriveMode(uint8 mode) ;
uint8   Opto_ReadDataReg(void) ;
uint8   Opto_Read(void) ;
uint8   Opto_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Opto_DRIVE_MODE_BITS        (3)
#define Opto_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - Opto_DRIVE_MODE_BITS))

#define Opto_DM_ALG_HIZ         (0x00u)
#define Opto_DM_DIG_HIZ         (0x01u)
#define Opto_DM_RES_UP          (0x02u)
#define Opto_DM_RES_DWN         (0x03u)
#define Opto_DM_OD_LO           (0x04u)
#define Opto_DM_OD_HI           (0x05u)
#define Opto_DM_STRONG          (0x06u)
#define Opto_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define Opto_MASK               Opto__MASK
#define Opto_SHIFT              Opto__SHIFT
#define Opto_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Opto_PS                     (* (reg32 *) Opto__PS)
/* Port Configuration */
#define Opto_PC                     (* (reg32 *) Opto__PC)
/* Data Register */
#define Opto_DR                     (* (reg32 *) Opto__DR)
/* Input Buffer Disable Override */
#define Opto_INP_DIS                (* (reg32 *) Opto__PC2)


#if defined(Opto__INTSTAT)  /* Interrupt Registers */

    #define Opto_INTSTAT                (* (reg32 *) Opto__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define Opto_DRIVE_MODE_SHIFT       (0x00u)
#define Opto_DRIVE_MODE_MASK        (0x07u << Opto_DRIVE_MODE_SHIFT)


#endif /* End Pins Opto_H */


/* [] END OF FILE */
