/*******************************************************************************
* File Name: StopIrr.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_StopIrr_H) /* Pins StopIrr_H */
#define CY_PINS_StopIrr_H

#include "cytypes.h"
#include "cyfitter.h"
#include "StopIrr_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    StopIrr_Write(uint8 value) ;
void    StopIrr_SetDriveMode(uint8 mode) ;
uint8   StopIrr_ReadDataReg(void) ;
uint8   StopIrr_Read(void) ;
uint8   StopIrr_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define StopIrr_DRIVE_MODE_BITS        (3)
#define StopIrr_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - StopIrr_DRIVE_MODE_BITS))

#define StopIrr_DM_ALG_HIZ         (0x00u)
#define StopIrr_DM_DIG_HIZ         (0x01u)
#define StopIrr_DM_RES_UP          (0x02u)
#define StopIrr_DM_RES_DWN         (0x03u)
#define StopIrr_DM_OD_LO           (0x04u)
#define StopIrr_DM_OD_HI           (0x05u)
#define StopIrr_DM_STRONG          (0x06u)
#define StopIrr_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define StopIrr_MASK               StopIrr__MASK
#define StopIrr_SHIFT              StopIrr__SHIFT
#define StopIrr_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define StopIrr_PS                     (* (reg32 *) StopIrr__PS)
/* Port Configuration */
#define StopIrr_PC                     (* (reg32 *) StopIrr__PC)
/* Data Register */
#define StopIrr_DR                     (* (reg32 *) StopIrr__DR)
/* Input Buffer Disable Override */
#define StopIrr_INP_DIS                (* (reg32 *) StopIrr__PC2)


#if defined(StopIrr__INTSTAT)  /* Interrupt Registers */

    #define StopIrr_INTSTAT                (* (reg32 *) StopIrr__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define StopIrr_DRIVE_MODE_SHIFT       (0x00u)
#define StopIrr_DRIVE_MODE_MASK        (0x07u << StopIrr_DRIVE_MODE_SHIFT)


#endif /* End Pins StopIrr_H */


/* [] END OF FILE */
