/*******************************************************************************
* File Name: YellowLed.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_YellowLed_H) /* Pins YellowLed_H */
#define CY_PINS_YellowLed_H

#include "cytypes.h"
#include "cyfitter.h"
#include "YellowLed_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    YellowLed_Write(uint8 value) ;
void    YellowLed_SetDriveMode(uint8 mode) ;
uint8   YellowLed_ReadDataReg(void) ;
uint8   YellowLed_Read(void) ;
uint8   YellowLed_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define YellowLed_DRIVE_MODE_BITS        (3)
#define YellowLed_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - YellowLed_DRIVE_MODE_BITS))

#define YellowLed_DM_ALG_HIZ         (0x00u)
#define YellowLed_DM_DIG_HIZ         (0x01u)
#define YellowLed_DM_RES_UP          (0x02u)
#define YellowLed_DM_RES_DWN         (0x03u)
#define YellowLed_DM_OD_LO           (0x04u)
#define YellowLed_DM_OD_HI           (0x05u)
#define YellowLed_DM_STRONG          (0x06u)
#define YellowLed_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define YellowLed_MASK               YellowLed__MASK
#define YellowLed_SHIFT              YellowLed__SHIFT
#define YellowLed_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define YellowLed_PS                     (* (reg32 *) YellowLed__PS)
/* Port Configuration */
#define YellowLed_PC                     (* (reg32 *) YellowLed__PC)
/* Data Register */
#define YellowLed_DR                     (* (reg32 *) YellowLed__DR)
/* Input Buffer Disable Override */
#define YellowLed_INP_DIS                (* (reg32 *) YellowLed__PC2)


#if defined(YellowLed__INTSTAT)  /* Interrupt Registers */

    #define YellowLed_INTSTAT                (* (reg32 *) YellowLed__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define YellowLed_DRIVE_MODE_SHIFT       (0x00u)
#define YellowLed_DRIVE_MODE_MASK        (0x07u << YellowLed_DRIVE_MODE_SHIFT)


#endif /* End Pins YellowLed_H */


/* [] END OF FILE */
