/*******************************************************************************
* File Name: An2.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_An2_H) /* Pins An2_H */
#define CY_PINS_An2_H

#include "cytypes.h"
#include "cyfitter.h"
#include "An2_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    An2_Write(uint8 value) ;
void    An2_SetDriveMode(uint8 mode) ;
uint8   An2_ReadDataReg(void) ;
uint8   An2_Read(void) ;
uint8   An2_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define An2_DRIVE_MODE_BITS        (3)
#define An2_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - An2_DRIVE_MODE_BITS))

#define An2_DM_ALG_HIZ         (0x00u)
#define An2_DM_DIG_HIZ         (0x01u)
#define An2_DM_RES_UP          (0x02u)
#define An2_DM_RES_DWN         (0x03u)
#define An2_DM_OD_LO           (0x04u)
#define An2_DM_OD_HI           (0x05u)
#define An2_DM_STRONG          (0x06u)
#define An2_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define An2_MASK               An2__MASK
#define An2_SHIFT              An2__SHIFT
#define An2_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define An2_PS                     (* (reg32 *) An2__PS)
/* Port Configuration */
#define An2_PC                     (* (reg32 *) An2__PC)
/* Data Register */
#define An2_DR                     (* (reg32 *) An2__DR)
/* Input Buffer Disable Override */
#define An2_INP_DIS                (* (reg32 *) An2__PC2)


#if defined(An2__INTSTAT)  /* Interrupt Registers */

    #define An2_INTSTAT                (* (reg32 *) An2__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define An2_DRIVE_MODE_SHIFT       (0x00u)
#define An2_DRIVE_MODE_MASK        (0x07u << An2_DRIVE_MODE_SHIFT)


#endif /* End Pins An2_H */


/* [] END OF FILE */
