/*******************************************************************************
* File Name: An3.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_An3_H) /* Pins An3_H */
#define CY_PINS_An3_H

#include "cytypes.h"
#include "cyfitter.h"
#include "An3_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    An3_Write(uint8 value) ;
void    An3_SetDriveMode(uint8 mode) ;
uint8   An3_ReadDataReg(void) ;
uint8   An3_Read(void) ;
uint8   An3_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define An3_DRIVE_MODE_BITS        (3)
#define An3_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - An3_DRIVE_MODE_BITS))

#define An3_DM_ALG_HIZ         (0x00u)
#define An3_DM_DIG_HIZ         (0x01u)
#define An3_DM_RES_UP          (0x02u)
#define An3_DM_RES_DWN         (0x03u)
#define An3_DM_OD_LO           (0x04u)
#define An3_DM_OD_HI           (0x05u)
#define An3_DM_STRONG          (0x06u)
#define An3_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define An3_MASK               An3__MASK
#define An3_SHIFT              An3__SHIFT
#define An3_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define An3_PS                     (* (reg32 *) An3__PS)
/* Port Configuration */
#define An3_PC                     (* (reg32 *) An3__PC)
/* Data Register */
#define An3_DR                     (* (reg32 *) An3__DR)
/* Input Buffer Disable Override */
#define An3_INP_DIS                (* (reg32 *) An3__PC2)


#if defined(An3__INTSTAT)  /* Interrupt Registers */

    #define An3_INTSTAT                (* (reg32 *) An3__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define An3_DRIVE_MODE_SHIFT       (0x00u)
#define An3_DRIVE_MODE_MASK        (0x07u << An3_DRIVE_MODE_SHIFT)


#endif /* End Pins An3_H */


/* [] END OF FILE */
