/*******************************************************************************
* File Name: An4.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_An4_H) /* Pins An4_H */
#define CY_PINS_An4_H

#include "cytypes.h"
#include "cyfitter.h"
#include "An4_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    An4_Write(uint8 value) ;
void    An4_SetDriveMode(uint8 mode) ;
uint8   An4_ReadDataReg(void) ;
uint8   An4_Read(void) ;
uint8   An4_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define An4_DRIVE_MODE_BITS        (3)
#define An4_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - An4_DRIVE_MODE_BITS))

#define An4_DM_ALG_HIZ         (0x00u)
#define An4_DM_DIG_HIZ         (0x01u)
#define An4_DM_RES_UP          (0x02u)
#define An4_DM_RES_DWN         (0x03u)
#define An4_DM_OD_LO           (0x04u)
#define An4_DM_OD_HI           (0x05u)
#define An4_DM_STRONG          (0x06u)
#define An4_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define An4_MASK               An4__MASK
#define An4_SHIFT              An4__SHIFT
#define An4_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define An4_PS                     (* (reg32 *) An4__PS)
/* Port Configuration */
#define An4_PC                     (* (reg32 *) An4__PC)
/* Data Register */
#define An4_DR                     (* (reg32 *) An4__DR)
/* Input Buffer Disable Override */
#define An4_INP_DIS                (* (reg32 *) An4__PC2)


#if defined(An4__INTSTAT)  /* Interrupt Registers */

    #define An4_INTSTAT                (* (reg32 *) An4__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define An4_DRIVE_MODE_SHIFT       (0x00u)
#define An4_DRIVE_MODE_MASK        (0x07u << An4_DRIVE_MODE_SHIFT)


#endif /* End Pins An4_H */


/* [] END OF FILE */
