/*******************************************************************************
* File Name: RedLed.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_RedLed_H) /* Pins RedLed_H */
#define CY_PINS_RedLed_H

#include "cytypes.h"
#include "cyfitter.h"
#include "RedLed_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    RedLed_Write(uint8 value) ;
void    RedLed_SetDriveMode(uint8 mode) ;
uint8   RedLed_ReadDataReg(void) ;
uint8   RedLed_Read(void) ;
uint8   RedLed_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define RedLed_DRIVE_MODE_BITS        (3)
#define RedLed_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - RedLed_DRIVE_MODE_BITS))

#define RedLed_DM_ALG_HIZ         (0x00u)
#define RedLed_DM_DIG_HIZ         (0x01u)
#define RedLed_DM_RES_UP          (0x02u)
#define RedLed_DM_RES_DWN         (0x03u)
#define RedLed_DM_OD_LO           (0x04u)
#define RedLed_DM_OD_HI           (0x05u)
#define RedLed_DM_STRONG          (0x06u)
#define RedLed_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define RedLed_MASK               RedLed__MASK
#define RedLed_SHIFT              RedLed__SHIFT
#define RedLed_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define RedLed_PS                     (* (reg32 *) RedLed__PS)
/* Port Configuration */
#define RedLed_PC                     (* (reg32 *) RedLed__PC)
/* Data Register */
#define RedLed_DR                     (* (reg32 *) RedLed__DR)
/* Input Buffer Disable Override */
#define RedLed_INP_DIS                (* (reg32 *) RedLed__PC2)


#if defined(RedLed__INTSTAT)  /* Interrupt Registers */

    #define RedLed_INTSTAT                (* (reg32 *) RedLed__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define RedLed_DRIVE_MODE_SHIFT       (0x00u)
#define RedLed_DRIVE_MODE_MASK        (0x07u << RedLed_DRIVE_MODE_SHIFT)


#endif /* End Pins RedLed_H */


/* [] END OF FILE */
