/*******************************************************************************
* File Name: SetIntel.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_SetIntel_H) /* Pins SetIntel_H */
#define CY_PINS_SetIntel_H

#include "cytypes.h"
#include "cyfitter.h"
#include "SetIntel_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    SetIntel_Write(uint8 value) ;
void    SetIntel_SetDriveMode(uint8 mode) ;
uint8   SetIntel_ReadDataReg(void) ;
uint8   SetIntel_Read(void) ;
uint8   SetIntel_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define SetIntel_DRIVE_MODE_BITS        (3)
#define SetIntel_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - SetIntel_DRIVE_MODE_BITS))

#define SetIntel_DM_ALG_HIZ         (0x00u)
#define SetIntel_DM_DIG_HIZ         (0x01u)
#define SetIntel_DM_RES_UP          (0x02u)
#define SetIntel_DM_RES_DWN         (0x03u)
#define SetIntel_DM_OD_LO           (0x04u)
#define SetIntel_DM_OD_HI           (0x05u)
#define SetIntel_DM_STRONG          (0x06u)
#define SetIntel_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define SetIntel_MASK               SetIntel__MASK
#define SetIntel_SHIFT              SetIntel__SHIFT
#define SetIntel_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define SetIntel_PS                     (* (reg32 *) SetIntel__PS)
/* Port Configuration */
#define SetIntel_PC                     (* (reg32 *) SetIntel__PC)
/* Data Register */
#define SetIntel_DR                     (* (reg32 *) SetIntel__DR)
/* Input Buffer Disable Override */
#define SetIntel_INP_DIS                (* (reg32 *) SetIntel__PC2)


#if defined(SetIntel__INTSTAT)  /* Interrupt Registers */

    #define SetIntel_INTSTAT                (* (reg32 *) SetIntel__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define SetIntel_DRIVE_MODE_SHIFT       (0x00u)
#define SetIntel_DRIVE_MODE_MASK        (0x07u << SetIntel_DRIVE_MODE_SHIFT)


#endif /* End Pins SetIntel_H */


/* [] END OF FILE */
