/*******************************************************************************
* File Name: StartIrr.h  
* Version 2.10
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_StartIrr_H) /* Pins StartIrr_H */
#define CY_PINS_StartIrr_H

#include "cytypes.h"
#include "cyfitter.h"
#include "StartIrr_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    StartIrr_Write(uint8 value) ;
void    StartIrr_SetDriveMode(uint8 mode) ;
uint8   StartIrr_ReadDataReg(void) ;
uint8   StartIrr_Read(void) ;
uint8   StartIrr_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define StartIrr_DRIVE_MODE_BITS        (3)
#define StartIrr_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - StartIrr_DRIVE_MODE_BITS))

#define StartIrr_DM_ALG_HIZ         (0x00u)
#define StartIrr_DM_DIG_HIZ         (0x01u)
#define StartIrr_DM_RES_UP          (0x02u)
#define StartIrr_DM_RES_DWN         (0x03u)
#define StartIrr_DM_OD_LO           (0x04u)
#define StartIrr_DM_OD_HI           (0x05u)
#define StartIrr_DM_STRONG          (0x06u)
#define StartIrr_DM_RES_UPDWN       (0x07u)

/* Digital Port Constants */
#define StartIrr_MASK               StartIrr__MASK
#define StartIrr_SHIFT              StartIrr__SHIFT
#define StartIrr_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define StartIrr_PS                     (* (reg32 *) StartIrr__PS)
/* Port Configuration */
#define StartIrr_PC                     (* (reg32 *) StartIrr__PC)
/* Data Register */
#define StartIrr_DR                     (* (reg32 *) StartIrr__DR)
/* Input Buffer Disable Override */
#define StartIrr_INP_DIS                (* (reg32 *) StartIrr__PC2)


#if defined(StartIrr__INTSTAT)  /* Interrupt Registers */

    #define StartIrr_INTSTAT                (* (reg32 *) StartIrr__INTSTAT)

#endif /* Interrupt Registers */


/***************************************
* The following code is DEPRECATED and 
* must not be used.
***************************************/

#define StartIrr_DRIVE_MODE_SHIFT       (0x00u)
#define StartIrr_DRIVE_MODE_MASK        (0x07u << StartIrr_DRIVE_MODE_SHIFT)


#endif /* End Pins StartIrr_H */


/* [] END OF FILE */
