/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "data_validation.h"

void check_xbee_data()
{
    uint8 i;
    if( XBeeRXbuffer[0] == ESCAPE1 )
    {
        if( XBeeRXbuffer[1] == ESCAPE5 )
        {
            for(i=0; i < XBeeRXDataLength-3; i++)
            {
                PSOCTXbuffer[i] = XBeeRXbuffer[i+2];   
            }
            TXDataLength = i;
            if(XBeeRXbuffer[i+2] != ESCAPE2)
            {
                //blink_redleds(2);
                PSOCRXOK = 0;
            }
            else
            {
                blink_greenleds(1);
                PSOCRXOK = 1;
            }
        }
        else
        {
            //blink_redleds(2);
            PSOCRXOK = 0;
        }
    }
    else
    {
        //blink_redleds(2);
        PSOCRXOK = 0;
    }
}

void check_command()
{
    uint16 *pch = 0;
    uint8 val, myret;
    uint8 pakw[2] = {0x00, 0x00};
    /** **/
        
    pch = bytetok(&val);
    
    switch(val)
    {   
                                //Reception of ~{ command, msblength, lsblength, sec, min, hour, t_irr, pwm1, pwm2, pwm3, pwm4, pwm5, days, drive, q, ph_obj, ph_offset, ce_obj, ce_offset, control_type, intel, program_num, sector}
        case    _PROG_SAVE_ :   myret = send_program_2_plc(pch);
                                if(!myret)
                                {
                                    pakw[1] = 0x01;
                                    PLCRXOK = 0;
                                }
                                akw_2_server(_PROG_SAVE_, 1, &pakw[0]);
                                break;
        
                                // ~{ command, sector, program number }
        case    _PROG_REQ_ :    if( control_get_irr_prog(pch) )
                                {
                                    
                                }
                                else
                                    PSOCRXOK = 0;
                                if (PLCRXOK == 1)
                                {
                                    pakw[1] = 0x01;
                                    PLCRXOK = 0;
                                }
                                akw_2_server(_PROG_SAVE_, 1, &pakw[0]);
                                break;
                                
        case    _SET_INTEL_ :   SetIntel_Write(1);
                                write2eeprom(ADDR_INTEL, 0x01);
                                pakw[1] = 0x01;
                                akw_2_server(_SET_INTEL_, 1, &pakw[0]);
                                break;
                                
        case    _UNSET_INTEL_ : SetIntel_Write(0);
                                write2eeprom(ADDR_INTEL, 0x00);
                                pakw[1] = 0x01;
                                akw_2_server(_UNSET_INTEL_, 1, &pakw[0]);
                                break;
                                
        case    _GET_INTEL_ :   pakw[1] = SetIntel_Read();
                                write2eeprom(ADDR_ALIXPING, 0x01);
                                akw_2_server(_GET_INTEL_, 1, &pakw[0]);
                                break;
                                
        case    _FORMAT_EE_ :   format_eeprom();
                                pakw[1] = 0x01;
                                akw_2_server(_FORMAT_EE_, 1, &pakw[0]);
                                break;
                                
        case    _START_IRR_ :   StartIrr_Write(1);
                                CyDelay(500);
                                StartIrr_Write(0);
                                pakw[1] = 0x01;
                                akw_2_server(_START_IRR_, 1, &pakw[0]);
                                break;
                                
        case    _STOP_IRR_ :    StopIrr_Write(1);
                                CyDelay(500);
                                StopIrr_Write(0);
                                pakw[1] = 0x01;
                                akw_2_server(_STOP_IRR_, 1, &pakw[0]);
                                break;
    }
    if( pch )
        free(pch);
}

uint16* bytetok(uint8 *command)
{
    uint16 c_tokens=0, i, j;
    uint16 *tokens=0;

    *command = 0x0000 | PSOCTXbuffer[0];
    c_tokens = PSOCTXbuffer[1] | PSOCTXbuffer[2];
    
    if(c_tokens)
    {
        tokens = (uint16*) malloc ( sizeof(uint16)*(c_tokens+1) );
        tokens[0] = c_tokens;
        for(i=4, j=0; j < TXDataLength; i++, j++)
        {
            tokens[j+1] = PSOCTXbuffer[i++] << 8;
            tokens[j+1] = tokens[j+1] | PSOCTXbuffer[i++];
        }
    }
        
    return tokens;
}

uint8 integer_bcd2char(uint8 data)
{
    return data+48;   
}

/**
* Función de respuesta al servidor "comm" comando del cual se hará respuesta; "length" tamaño del paquete a enviar,
* el paquete consta de 16 bits; "data" vector de 8 bits que contiene el paquete de enviar, cada dos entradas corresponde
* a un dato de 16 bits.
*
* @params comm
* @params length
* @params *data
**/
void akw_2_server(uint8 comm, uint16 length, uint8 *data)
{
    uint8 i;
    if(PSOCRXOK)
    {
        XBeeTXbuffer[0] = 0x7E;
        XBeeTXbuffer[1] = 0x7B;
        XBeeTXbuffer[2] = 0x01;
        XBeeTXbuffer[3] = _COMM_ACK_;
        XBeeTXbuffer[4] = (0xFF00 & (length+1)) << 8;
        XBeeTXbuffer[5] = (0x00FF & (length+1));
        XBeeTXbuffer[6] = TOKEN;
        XBeeTXbuffer[7] = (0xFF00 & comm) << 8;
        XBeeTXbuffer[8] = comm;
        XBeeTXbuffer[9] = TOKEN;
        for(i=0; i < (length*3);)
        {
            XBeeTXbuffer[10+i] = data[i];
            ++i;
            XBeeTXbuffer[10+i] = data[i];
            ++i;
            XBeeTXbuffer[10+i] = TOKEN;
            ++i;
        }
        XBeeTXbuffer[10+i-1] = 0x7D;
        TXDataLength = 10+i;
    }
    XBeeSendPacket();
}

uint8 int2char(uint8 data)
{
    if( data >= 0 && data <= 9 )
        return data + 0x30;
    if( data > 9 && data <= 15 )
        return data + 0x41;
    
    return 0;
}

uint8 char2int(uint8 data)
{
    if( data >= 48 && data <= 57 )
        return data - 48;
    if( toupper(data) >= 65 && toupper(data) <= 70 )
        return data - 55;
    
    return 0;
}

/* [] END OF FILE */
