/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "data_validation.h"

void check_xbee_data()
{
    uint8 i;
    if( XBeeRXbuffer[0] == ESCAPE1 )
    {
        if( XBeeRXbuffer[1] == ESCAPE5 )
        {
            for(i=0; i < XBeeRXDataLength-3; i++)
            {
                PSOCTXbuffer[i] = XBeeRXbuffer[i+2];   
            }
            TXDataLength = i;
            if(XBeeRXbuffer[i+2] != ESCAPE2)
            {
                blink_redleds(1);
                PSOCRXOK = 0;
            }
            else
            {
                blink_greenleds(1);
                PSOCRXOK = 1;
            }
        }
        else
        {
            blink_redleds(2);
            PSOCRXOK = 0;
        }
    }
    else
    {
        blink_redleds(4);
        PSOCRXOK = 0;
    }
}

void check_command()
{
    uint16 *pch = 0;
    uint8 val, myret;

    /** **/
        
    pch = bytetok(&val);
    
    switch(val)
    {   
                                //Reception of ~{ command, msblength, lsblength, sec, min, hour, t_irr, pwm1, pwm2, pwm3, pwm4, pwm5, days, drive, q, ph_obj, ph_offset, ce_obj, ce_offset, control_type, intel, program_num, sector}
        case    _PROG_SAVE_ :   myret = send_program_2_plc(pch);
                                uint8 psave[2] = {0x00, 0x00};
                                if(!myret)
                                {
                                    psave[1] = 0x01;
                                    PLCRXOK = 0;
                                }
                                akw_2_server(_PROG_SAVE_, 1, &psave[0]);
                                break;
        
                                // ~{ command, sector, program number }
        case    _PROG_REQ_ :    if( control_get_irr_prog(pch) )
                                {
                                    UARTSendPacket();
                                    PSOC2PSOCHandler();
                                }
                                else
                                    PSOCRXOK = 0;
                                uint8 pask[2] = {0x00, 0x00};
                                if (PLCRXOK == 1)
                                {
                                    pask[1] = 0x01;
                                    PLCRXOK = 0;
                                }
                                akw_2_server(_PROG_SAVE_, 1, &pask[0]);
                                break;                        
    }
    if( pch )
        free(pch);
}

uint16* bytetok(uint8 *command)
{
    uint16 c_tokens=0, i, j;
    uint16 *tokens=0;

    *command = 0x0000 | PSOCTXbuffer[0];
    c_tokens = PSOCTXbuffer[1] | PSOCTXbuffer[2];
    
    if(c_tokens)
    {
        tokens = (uint16*) malloc ( sizeof(uint16)*(c_tokens+1) );
        tokens[0] = c_tokens;
        for(i=4, j=0; j < TXDataLength; i++, j++)
        {
            tokens[j+1] = PSOCTXbuffer[i++] << 8;
            tokens[j+1] = tokens[j+1] | PSOCTXbuffer[i++];
        }
    }
        
    return tokens;
}

uint8 integer_bcd2char(uint8 data)
{
    return data+48;   
}

/**
* Función de respuesta al servidor "comm" comando del cual se hará respuesta; "length" tamaño del paquete a enviar,
* el paquete consta de 16 bits; "data" vector de 8 bits que contiene el paquete de enviar, cada dos entradas corresponde
* a un dato de 16 bits.
*
* @params comm
* @params length
* @params *data
**/
void akw_2_server(uint8 comm, uint16 length, uint8 *data)
{
    uint8 i;
    if(PSOCRXOK)
    {
        XBeeTXbuffer[0] = 0x7E;
        XBeeTXbuffer[1] = 0x7B;
        XBeeTXbuffer[2] = 0x01;
        XBeeTXbuffer[3] = _COMM_ACK_;
        XBeeTXbuffer[4] = (0xFF00 & (length+1)) << 8;
        XBeeTXbuffer[5] = (0x00FF & (length+1));
        XBeeTXbuffer[6] = TOKEN;
        XBeeTXbuffer[7] = (0xFF00 & comm) << 8;
        XBeeTXbuffer[8] = comm;
        XBeeTXbuffer[9] = TOKEN;
        for(i=0; i < (length*3);)
        {
            XBeeTXbuffer[10+i] = data[i];
            ++i;
            XBeeTXbuffer[10+i] = data[i];
            ++i;
            XBeeTXbuffer[10+i] = TOKEN;
            ++i;
        }
        XBeeTXbuffer[10+i-1] = 0x7D;
        TXDataLength = 10+i;
    }
    XBeeSendPacket();
}

void check_4_intel_prog()
{
    uint8 c_tokens=0, i, j, checksum=0;
    char *address, *data, *checksum_ascii;
    
    CyDelay(250);
    control_ask_4_intel_prog();
    UARTSendPacket();
    PSOC2PSOCHandler();
    CyDelay(100);
    
    for(i=0; i < RXDataLength; i++)
    {
        if( PSOCRXbuffer[i] == TOKEN )
            ++c_tokens;
    }
    //Reception of t_irrig, pwm1, pwm2, pwm3, pwm4, pwm5, sector, driver, q, ph_obj, ph_offset, ce_obj, ce_offset, control_type, intel
    if(c_tokens == 15)
    {
        if( PSOCRXbuffer[0] == _CHECK_IPROG_ )
        {
            for(i=2, j=0; i < RXDataLength; i++, j++)
            {
                GRALbuffer[j] = PSOCRXbuffer[i++] << 8;
                GRALbuffer[j] = GRALbuffer[j] | PSOCRXbuffer[i++];
            }
            
            for(i=0; i < 8; i++)
            {
                address = plc_addr_int2ascii(SEC_ALL_INTEL + (i*100));
                data = int2wordhex(GRALbuffer[i]);
                //Init Tx
                PLC_UART_UartPutChar(0x02);
                checksum += 0x02;
                //Station Number
                PLC_UART_UartPutChar(0x30);
                checksum += 0x30;
                PLC_UART_UartPutChar(0x31);
                checksum += 0x31;
                //Command Code
                PLC_UART_UartPutChar(0x34);
                checksum += 0x34;
                PLC_UART_UartPutChar(0x37);
                checksum += 0x37;
                //N bytes to Write
                PLC_UART_UartPutChar(0x30);
                checksum += 0x30;
                PLC_UART_UartPutChar(0x31);
                checksum += 0x31;
                //Register Address
                PLC_UART_UartPutChar(_R_);
                checksum += _R_;
                
                PLC_UART_UartPutChar(address[0]);
                checksum += address[0];
                PLC_UART_UartPutChar(address[1]);
                checksum += address[1];
                PLC_UART_UartPutChar(address[2]);
                checksum += address[2];
                PLC_UART_UartPutChar(address[3]);
                checksum += address[3];
                PLC_UART_UartPutChar(address[4]);
                checksum += address[4];
                free(address);
                //Data
                PLC_UART_UartPutChar(data[0]);
                checksum += data[0];
                PLC_UART_UartPutChar(data[1]);
                checksum += data[1];
                PLC_UART_UartPutChar(data[2]);
                checksum += data[2];
                PLC_UART_UartPutChar(data[3]);
                checksum += data[3];
                free(data);
                //Checksum
                checksum_ascii = int2wordhex(checksum);
                PLC_UART_UartPutChar(checksum_ascii[2]);
                PLC_UART_UartPutChar(checksum_ascii[3]);
                free(checksum_ascii);
                //End of Transmission
                PLC_UART_UartPutChar(0x03);
                
                PLCPacketHandler();
                checksum = 0;
                CyDelay(1);
            }
            if(PLCRXOK)
            {
                blink_yellowleds(5);
                PSOCTXbuffer[0] = _START_IRR_;
                TXDataLength = 1;
                UARTSendPacket();
                PSOC2PSOCHandler();
                if(PSOCRXOK)
                {
                    if( PSOCRXbuffer[0] == _START_IRR_ && PSOCRXbuffer[2] == 'o' && PSOCRXbuffer[3] == 'k')
                    {
                        blink_greenleds(2);
                        blink_redleds(2);
                        blink_yellowleds(2);
                    }
                    else
                        blink_redleds(3);
                    PSOCRXOK = 0;
                }
                PLCRXOK = 0;
            }
        }
    }
}

uint8 int2char(uint8 data)
{
    if( data >= 0 && data <= 9 )
        return data + 0x30;
    if( data > 9 && data <= 15 )
        return data + 0x41;
    
    return 0;
}

/* [] END OF FILE */
