/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "i2c_.h"

int8 format_eeprom()
{
    uint8 status;
    uint16 address = 0x0000;
    uint8 addr_lsb, addr_msb;
    
    while(address <= ADDR_END)
    {    
        addr_lsb = address;
        addr_msb = (address & 0xFF00) >> 8;
        
        I2C_Start();
        CyDelayUs(10);
        
        status = I2C_I2CMasterSendStart(ADDR_EEPROM, I2C_I2C_WRITE_XFER_MODE);
        CyDelayUs(10);
        if(status)
        {
            return -1;
        }
        
        /*status = I2C_I2CMasterWriteByte(address);
        CyDelayUs(10);
        if(status)
        {
            return -1;
        }*/
        status = I2C_I2CMasterWriteByte(addr_msb);
        CyDelayUs(10);
        if(status)
        {
            return -1;
        }
        
        status = I2C_I2CMasterWriteByte(addr_lsb);
        CyDelayUs(10);
        if(status)
        {
            return -1;
        }
        
        status = I2C_I2CMasterWriteByte(0x00);
        CyDelayUs(10);
        if(status)
        {
            return -1;
        }
        
        I2C_I2CMasterSendStop();
        address++;     
        CyDelay(10);
    }
    return 0;
}

int8 write2eeprom(uint16 address, uint8 data)
{
    uint8 status;
    uint8 addr_lsb, addr_msb;
    
    addr_lsb = address;
    addr_msb = (address & 0xFF00) >> 8;
        
    I2C_Start();
    CyDelayUs(10);
    
    status = I2C_I2CMasterSendStart(ADDR_EEPROM, I2C_I2C_WRITE_XFER_MODE);
    CyDelayUs(10);
    if(status)
        return -1;
    
    /*status = I2C_I2CMasterWriteByte(address);
    CyDelayUs(10);
    if(status)
    {
        return -1;
    }*/
    status = I2C_I2CMasterWriteByte(addr_msb);
    CyDelayUs(10);
    if(status)
    {
        return -1;
    }
    
    status = I2C_I2CMasterWriteByte(addr_lsb);
    CyDelayUs(10);
    if(status)
    {
        return -1;
    }
    
    status = I2C_I2CMasterWriteByte(data);
    CyDelayUs(10);
    if(status)
        return -1;
    
    I2C_I2CMasterSendStop();
    CyDelay(10);
    return 0;
}

int8 read_from_eeprom(uint16 address, uint8 *data)
{
    uint8 status;
    uint8 addr_lsb, addr_msb;
    
    addr_lsb = address;
    addr_msb = (address & 0xFF00) >> 8;
    
    I2C_Start();
    CyDelayUs(10);
    
    status = I2C_I2CMasterSendStart(ADDR_EEPROM, I2C_I2C_WRITE_XFER_MODE);
    CyDelayUs(10);
    if(status)
        return -1;
    
    /*status = I2C_I2CMasterWriteByte(address);
    CyDelayUs(10);
    if(status)
    {
        return -1;
    }*/
    status = I2C_I2CMasterWriteByte(addr_msb);
    CyDelayUs(10);
    if(status)
    {
        return -1;
    }
    
    status = I2C_I2CMasterWriteByte(addr_lsb);
    CyDelayUs(10);
    if(status)
    {
        return -1;
    }
    
    status = I2C_I2CMasterSendRestart(ADDR_EEPROM, I2C_I2C_READ_XFER_MODE);
    CyDelayUs(10);
    if(status)
        return -1;
    
    *data = I2C_I2CMasterReadByte(I2C_I2C_NAK_DATA);
    I2C_I2CMasterSendStop();
    
    return 0;
}

