/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "main.h"

int main()
{
    uint8 i;
    vars_init();
    sys_init();
    
    for(;;)
    {
        if(ACKINTCLK)
        {
            XBEE_UART_DisableInt();
            //pull_plc_info();
            ACKINTCLK = 0;
            isr_ACKTimer_StartEx(&IntACKTimer);
            ACKTimer_Start();
            XBEE_UART_EnableInt();
        }
        if(XBEERXOK)
        {
            XBEE_UART_DisableInt();
            
            check_xbee_data();
            if(PSOCRXOK)
            {
                check_command();
                PSOCRXOK = 0;
            }
            XBEERXOK = 0;
            XBEE_UART_EnableInt();
        }        
        if(PLCINTCLK)
        {
            PLCINTCLK = 0;
            PLCRXOK = 0;
        }
        if(PSOCINTCLK)
        {
            PSOCINTCLK = 0;   
        }
        CyDelay(10);
    }
}

void vars_init()
{
    XBEERXOK = 0;
    XBEETXOK = 0;
    PLCRXOK = 0;
    PLCTXOK = 0;
    PLCINTCLK = 0;
    PLCINTCLK = 0;
    ACKINTCLK = 0;
}

void sys_init()
{
    CyDelay(2000);
	XBEE_UART_Start();
    PLC_UART_Start();
    PSOC_UART_Start();
    
    CyDelayUs(50);
    
    XBEE_UART_SetCustomInterruptHandler(&XBeePacketHandler);
    
    isr_ACKTimer_StartEx(&IntACKTimer);
    ACKTimer_Start();
	CyGlobalIntEnable;
}

void pull_plc_info()
{
    uint16 v_ph=0, v_ce=0, sector, prognum, qhigh=0, qlow=0;
    check_4_intel_prog();
    if( check_plc_data(irrigation_reg) )
    {
        XBeeTXbuffer[0] = '~';
        XBeeTXbuffer[1] = '{';
        XBeeTXbuffer[2] = 0x01;
        XBeeTXbuffer[3] = _START_IRR_;
        XBeeTXbuffer[4] = 0x00;
        XBeeTXbuffer[5] = 0x03;
        XBeeTXbuffer[6] = TOKEN;
        XBeeTXbuffer[7] = 0x00;
        XBeeTXbuffer[8] = 0x01;
        
        sector = check_plc_data(sector_reg);
        XBeeTXbuffer[9] = TOKEN;
        XBeeTXbuffer[10] = (sector & 0xFF00) >> 8;
        XBeeTXbuffer[11] = sector & 0x00FF;
        
        prognum = check_plc_data(prognum_reg);
        XBeeTXbuffer[12] = TOKEN;
        XBeeTXbuffer[13] = (prognum & 0xFF00) >> 8;
        XBeeTXbuffer[14] = prognum & 0x00FF;
        XBeeTXbuffer[15] = '}';
        TXDataLength = 16;
        XBeeSendPacket();
        
        v_ce = check_plc_data(ce_reg);
        XBeeTXbuffer[0] = '~';
        XBeeTXbuffer[1] = '{';
        XBeeTXbuffer[2] = 0x00;
        XBeeTXbuffer[3] = 0x5A;
        XBeeTXbuffer[4] = 0x00;
        XBeeTXbuffer[5] = 0x01;
        XBeeTXbuffer[6] = TOKEN;
        XBeeTXbuffer[7] = (v_ce & 0xFF00) >> 8;
        XBeeTXbuffer[8] = v_ce & 0x00FF;
        XBeeTXbuffer[9] = '}';
        TXDataLength = 10;
        XBeeSendPacket();
        
        v_ph = check_plc_data(ph_reg);
        XBeeTXbuffer[0] = '~';
        XBeeTXbuffer[1] = '{';
        XBeeTXbuffer[2] = 0x00;
        XBeeTXbuffer[3] = 0x59;
        XBeeTXbuffer[4] = 0x00;
        XBeeTXbuffer[5] = 0x01;
        XBeeTXbuffer[6] = TOKEN;
        XBeeTXbuffer[7] = (v_ph & 0xFF00) >> 8;
        XBeeTXbuffer[8] = v_ph & 0x00FF;
        XBeeTXbuffer[9] = '}';
        TXDataLength = 10;
        XBeeSendPacket();
        
        qhigh = check_plc_data(Q_reg_high);
        qlow = check_plc_data(Q_reg_low);
        XBeeTXbuffer[0] = '~';
        XBeeTXbuffer[1] = '{';
        XBeeTXbuffer[2] = 0x00;
        XBeeTXbuffer[3] = 0x28;
        XBeeTXbuffer[4] = 0x00;
        XBeeTXbuffer[5] = 0x02;
        XBeeTXbuffer[6] = TOKEN;
        XBeeTXbuffer[7] = (qhigh & 0xFF00) >> 8;
        XBeeTXbuffer[8] = qhigh & 0x00FF;
        XBeeTXbuffer[9] = TOKEN;
        XBeeTXbuffer[10] = (qlow & 0xFF00) >> 8;
        XBeeTXbuffer[11] = qlow & 0x00FF;
        XBeeTXbuffer[12] = '}';
                
        TXDataLength = 13;
        XBeeSendPacket();
    }
    else
    {
        XBeeTXbuffer[0]  = '~';
        XBeeTXbuffer[1]  = '{';
        XBeeTXbuffer[2] = 0x01;
        XBeeTXbuffer[3]  = _START_IRR_;
        XBeeTXbuffer[4] = 0x00;
        XBeeTXbuffer[5] = 0x03;
        XBeeTXbuffer[6]  = TOKEN;
        XBeeTXbuffer[7]  = 0x00;
        XBeeTXbuffer[8]  = 0x00;
        XBeeTXbuffer[9]  = TOKEN;
        XBeeTXbuffer[10]  = 0x00;
        XBeeTXbuffer[11]  = 0x00;
        XBeeTXbuffer[12]  = TOKEN;
        XBeeTXbuffer[13] = 0x00;
        XBeeTXbuffer[14] = 0x00;
        XBeeTXbuffer[15] = '}';
        
        TXDataLength = 16;
        XBeeSendPacket();
    }
    blink_redleds(3);
}

void IntACKTimer(void)
{    
    if( ACKTimer_GetInterruptSource() && ACKTimer_INTR_MASK_TC)
    {
        ACKINTCLK = 1;
        blink_yellowleds(3);
        isr_ACKTimer_ClearPending();
        ACKTimer_ClearInterrupt(ACKTimer_INTR_MASK_TC);
    }
    else
    {
        ACKTimer_ClearInterrupt(ACKTimer_INTR_MASK_CC_MATCH);
    }
}