/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "plc.h"

void PLCPacketHandler()
{
    uint8 tempchar;
    int i=0, j=0;
    
    if(!PLCINTCLK)
    {
        isr_PLCTimer_StartEx(&IntPLCTimer);
        PLCTimer_Start();
        
        do
        {
            while(PLC_UART_SpiUartGetRxBufferSize() == 0)
            {
                if(j > 2000)
                    PLCINTCLK = 1;
                if(PLCINTCLK)
                    return;
                CyDelayUs(10);
                j++;
            }
            tempchar = PLC_UART_UartGetChar(); // toma el dato del PLC
        } while(tempchar != 0x02);
        PLCRXbuffer[i] = tempchar;
        i++;
        j=0;
        do
        {
            while(PLC_UART_SpiUartGetRxBufferSize() == 0)
            {
                if(j > 2000)
                    PLCINTCLK = 1;
                if(PLCINTCLK)
                    return;
                CyDelayUs(10);
                j++;
            }
            tempchar = PLC_UART_UartGetChar(); // toma el dato del PLC
            PLCRXbuffer[i] = tempchar;
            i++;
            j=0;
        } while(tempchar != 0x03 && i < 99);
        
        if(tempchar == 0x03)
        {
            PLCTimer_Stop();
            PLCRXbuffer[i] = '\0';
            PLCRXOK = 1;
            blink_greenleds(2);
        }
        else
        {
            PLCTimer_Stop();
            PLCINTCLK = 1;
            blink_redleds(2);
        }
        
        return;
    }
    else
        return;
}

uint8 validate_plc_write()
{
     if( PLCRXbuffer[0] == 0x02 && PLCRXbuffer[1] == 0x30 && PLCRXbuffer[2] == 0x31 && PLCRXbuffer[3] == 0x34 && PLCRXbuffer[4] == 0x37 )
        return (PLCRXbuffer[5] - 0x30);
     return 0x01;
}

uint8 send_program_2_plc(uint16 *pch)
{
    uint8 sector=0, num_prog=0;
    int eeprom_addr;
    
    //pch = [length, sec, min, hour, t_irr, pwm1, pwm2, pwm3, pwm4, pwm5, days, drive, q, ph_obj, ph_offset, ce_obj, ce_offset, control_type, intel, program_num, sector]
    num_prog    = pch[19];
    PLC_UART_UartPutChar( num_prog );
    sector      = pch[20];
    PLC_UART_UartPutChar( sector );
    
    if(num_prog > 0 && num_prog < 9)
    {
        switch(sector)
        {
            case    1:  eeprom_addr = SEC1_PROG1 + ( (num_prog-1) * 10 );
                        break;
            case    2:  eeprom_addr = SEC2_PROG1 + ( (num_prog-1) * 10 );
                        break;
            case    3:  eeprom_addr = SEC3_PROG1 + ( (num_prog-1) * 10 );
                        break;
            case    4:  eeprom_addr = SEC4_PROG1 + ( (num_prog-1) * 10 );
                        break;
            case    5:  eeprom_addr = SEC5_PROG1 + ( (num_prog-1) * 10 );
                        break;
            case    6:  eeprom_addr = SEC6_PROG1 + ( (num_prog-1) * 10 );
                        break;
            case    7:  eeprom_addr = SEC7_PROG1 + ( (num_prog-1) * 10 );
                        break;
            case    8:  eeprom_addr = SEC8_PROG1 + ( (num_prog-1) * 10 );
                        break;
            case    9:  eeprom_addr = SEC9_PROG1 + ( (num_prog-1) * 10 );
                        break;
            default:    return 1;
        }
        return send_programs(pch, eeprom_addr, 10);
    }
    if(num_prog == 0)
    {
        switch(sector)
        {
            case    1:  eeprom_addr = SEC1_MAN;
                        break;
            case    2:  eeprom_addr = SEC2_MAN;
                        break;
            case    3:  eeprom_addr = SEC3_MAN;
                        break;
            case    4:  eeprom_addr = SEC4_MAN;
                        break;
            case    5:  eeprom_addr = SEC5_MAN;
                        break;
            case    6:  eeprom_addr = SEC6_MAN;
                        break;
            case    7:  eeprom_addr = SEC7_MAN;
                        break;
            case    8:  eeprom_addr = SEC8_MAN;
                        break;
            case    9:  eeprom_addr = SEC9_MAN;
                        break;
            default:    return 1;
        }
        return send_programs(pch, eeprom_addr, 5);
    }
    if(num_prog == 6)
    {
        eeprom_addr = SEC_ALL_INTEL;
        return send_programs(pch, eeprom_addr, 9);
    }
    return 1;
}

uint8 send_programs(uint16 *pch, int eeprom_addr, uint8 iterator)
{
    uint8 i, j, checksum=0, tryout=0;
    char *address, *data, *checksum_ascii;
    
    for(i=0; i < iterator; i++)
    {
        //for(tryout=0; tryout<3; tryout++)
        //{
            address = plc_addr_int2ascii(eeprom_addr + (i*100));
            data = int2wordhex(pch[i+1]);
            //Init Tx
            PLC_UART_UartPutChar(0x02);
            checksum += 0x02;
            //Station Numbe1
            PLC_UART_UartPutChar(0x30);
            checksum += 0x30;
            PLC_UART_UartPutChar(0x31);
            checksum += 0x31;
            //Command Code
            PLC_UART_UartPutChar(0x34);
            checksum += 0x34;
            PLC_UART_UartPutChar(0x37);
            checksum += 0x37;
            //N bytes to Write
            PLC_UART_UartPutChar(0x30);
            checksum += 0x30;
            PLC_UART_UartPutChar(0x31);
            checksum += 0x31;
            //Register Address
            PLC_UART_UartPutChar(_R_);
            checksum += _R_;
            
            PLC_UART_UartPutChar(address[0]);
            checksum += address[0];
            PLC_UART_UartPutChar(address[1]);
            checksum += address[1];
            PLC_UART_UartPutChar(address[2]);
            checksum += address[2];
            PLC_UART_UartPutChar(address[3]);
            checksum += address[3];
            PLC_UART_UartPutChar(address[4]);
            checksum += address[4];
            free(address);
            //Data
            PLC_UART_UartPutChar(data[0]);
            checksum += data[0];
            PLC_UART_UartPutChar(data[1]);
            checksum += data[1];
            PLC_UART_UartPutChar(data[2]);
            checksum += data[2];
            PLC_UART_UartPutChar(data[3]);
            checksum += data[3];
            free(data);
            //Checksum
            checksum_ascii = int2wordhex(checksum);
            PLC_UART_UartPutChar(checksum_ascii[2]);
            PLC_UART_UartPutChar(checksum_ascii[3]);
            free(checksum_ascii);
            //End of Transmission
            PLC_UART_UartPutChar(0x03);
            
            //PLCPacketHandler();
            //if(PLCINTCLK)
            //    return 1;
            //if(validate_plc_write())
            //    return 1;
            checksum = 0;
            CyDelay(50);
        //}
        //if(tryout >= 3)
        //        return 1;
    }
    return 0;
}

void IntPLCTimer(void)
{
    if( PLCTimer_GetInterruptSource() && PLCTimer_INTR_MASK_TC)
    {
        PLCINTCLK = 1;
        blink_yellowleds(3);
        isr_PLCTimer_ClearPending();
        PLCTimer_ClearInterrupt(PLCTimer_INTR_MASK_TC);
    }
    else
    {
        PLCTimer_ClearInterrupt(PLCTimer_INTR_MASK_CC_MATCH);
    }
}

char* int2wordhex(uint16 data)
{
	char *hex = (char*) malloc ( sizeof(char) * 4 );
    
    sprintf(hex, "%04X", data);
	
	return hex;
}

uint16 check_plc_akw()
{
    uint8 command = ((PLCRXbuffer[3]-0x30) << 4) | (PLCRXbuffer[4]-0x30);
    
    switch(command)
    {
        case    0x46:   return get_read_data();
        
        case    0x47:   return get_read_data();
    }
    return 0;
}

uint16 get_read_data()
{
    uint16 value = 0x0000;
    
    if( PLCRXbuffer[5] == 0x30 )
    {
        value = (PLCRXbuffer[6]-0x30) << 12;
        value |= (PLCRXbuffer[7]-0x30) << 8;
        value |= (PLCRXbuffer[8]-0x30) << 4;
        value |= (PLCRXbuffer[9]-0x30);
    }
    else
        return 0;
    
    return value;
}

char* plc_addr_int2ascii(uint16 data)
{
    char *array=0;
    //PLC_UART_UartPutChar( (data & 0xFF00 >> 8 ) );
    //PLC_UART_UartPutChar( data & 0x00FF );
    array = (char*) malloc ( sizeof(char)*5 );

    sprintf(array, "%05d", data);
    return array;
}

uint16 check_plc_data(uint8 *data)
{
    uint8 i, cont=0;
    uint16 mydata = 0x0000;
    
    do
    {
        if(PLCINTCLK)
            PLCINTCLK=0;
        for(i=0; i < 16; i++)
            PLC_UART_UartPutChar(data[i]);
        PLCPacketHandler();
        CyDelay(10);
        cont++;
    }
    while(!PLCRXOK && cont < 10);
    
    if(cont  >= 10)
        return mydata;
    
    if( PLCRXbuffer[0] == 0x02 && PLCRXbuffer[1] == 0x30 && PLCRXbuffer[2] == 0x31 &&
        PLCRXbuffer[3] == 0x34 && PLCRXbuffer[4] == 0x36 && PLCRXbuffer[5] == 0x30)
    {
        if( PLCRXbuffer[6] >= 0x30 && PLCRXbuffer[6] <= 0x39)
            mydata = (PLCRXbuffer[6] - 48) << 12;
        else
            mydata = (PLCRXbuffer[6] - 55) << 12;
            
        if( PLCRXbuffer[7] >= 0x30 && PLCRXbuffer[7] <= 0x39)
            mydata = mydata | ((PLCRXbuffer[7] - 48) << 8);
        else
            mydata = mydata | ((PLCRXbuffer[7] - 55) << 8);
            
        if( PLCRXbuffer[8] >= 0x30 && PLCRXbuffer[8] <= 0x39)
            mydata = mydata | ((PLCRXbuffer[8] - 48) << 4);
        else
            mydata = mydata | ((PLCRXbuffer[8] - 55) << 4);
            
        if( PLCRXbuffer[9] >= 0x30 && PLCRXbuffer[9] <= 0x39)
            mydata = mydata | (PLCRXbuffer[9] - 48);
        else
            mydata = mydata | (PLCRXbuffer[9] - 55);
    }
        
    PLCRXOK = 0;
    return mydata;
}


/* [] END OF FILE */
