/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "psoc2psoc.h"

uint8 PSOC2PSOCHandler()
{
    uint8 tempchar, i=0;
    
    isr_PLCTimer_StartEx(&IntPSoCTimer);
    PLCTimer_Init();
    PLCTimer_Start();
    
    while(PSOC_UART_GetRxBufferSize() == 0)
    {
        CyDelayUs(10);
        if(PSOCINTCLK)
            return 0;
    }
    tempchar = PSOC_UART_GetChar();
    
    if( tempchar == ESCAPE1 )
    {
        while(PSOC_UART_GetRxBufferSize() == 0)
        {
            CyDelayUs(10);
            if(PSOCINTCLK)
                return 0;
        }
        tempchar = PSOC_UART_GetChar();
        if( tempchar == ESCAPE5 )
        {
               while(PSOC_UART_GetRxBufferSize() == 0)
               {
                    CyDelayUs(10);
                    if(PSOCINTCLK)
                        return 0;
                }
                tempchar = PSOC_UART_GetChar();
                while (tempchar != ESCAPE2)
                {
                    if(i < MAX_PACK_SIZE)
                        PSOCRXbuffer[i++] = tempchar;
                    else
                        return 0;
                    while(PSOC_UART_GetRxBufferSize() == 0)
                    {
                        CyDelayUs(10);
                        if(PSOCINTCLK)
                            return 0;
                    }
                    tempchar = PSOC_UART_GetChar();
                }
                PLCTimer_Stop();
                RXDataLength = i;
        }
        else
            return 0;
    }
    else
        return 0;
       
    return 1;
}

int UARTSendPacket()
{  
    int i;
    //****//
    PSOC_UART_PutChar(ESCAPE1);
    CyDelayUs(50);
    PSOC_UART_PutChar(ESCAPE5);
    CyDelayUs(50);
    for(i=0; i < TXDataLength; i++)
    {
        PSOC_UART_PutChar(PSOCTXbuffer[i]);
        CyDelayUs(50);
    }
    PSOC_UART_PutChar(ESCAPE2);
    CyDelayUs(50);
    return 0;
}

void IntPSoCTimer(void)
{
    if( PLCTimer_GetInterruptSource() && PLCTimer_INTR_MASK_TC)
    {
        PSOCINTCLK = 1;
        blink_yellowleds(4);
        isr_PLCTimer_ClearPending();
        PLCTimer_ClearInterrupt(PLCTimer_INTR_MASK_TC);
    }
    else
    {
        PLCTimer_ClearInterrupt(PLCTimer_INTR_MASK_CC_MATCH);
    }
}

/* [] END OF FILE */
