/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "xbee.h"

void XBeePacketHandler()
{
    uint8 serr=0, sdata=0;
    int i=0, k=0;
    xbee_pck *mypck;
    
	/* Check interrupt source*/
	if(XBEE_UART_GetRxBufferSize() > 0)
	{	
        //HEADER
        get_from_uart(&serr, &sdata, 0);
        
        if( sdata == 0x7E ) // compara el dato empieza con la cabecera del xbee 7E
        {
            //Creating package
            mypck = (xbee_pck*) malloc ( sizeof(xbee_pck) );
            
            //********** LENGTH **********//
            while(XBEE_UART_GetRxBufferSize() == 0)
                    CyDelayUs(1);
            get_from_uart(&serr, &sdata, 0);            
            mypck->length = (mypck->length | sdata) << 8;
            while(XBEE_UART_GetRxBufferSize() == 0)
                CyDelayUs(1);
            get_from_uart(&serr, &sdata, 0);
            mypck->length = mypck->length | sdata;
            
            //********** API ID **********//
            while(XBEE_UART_GetRxBufferSize() == 0)
                CyDelayUs(1);
            get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
            mypck->apiid = sdata;
            
            switch(mypck->apiid)
            {
                case 0x80:  
                            rx_64bitaddress(mypck);
                            break;
                case 0x89:  
                            rx_txstatus(mypck);
                            break;
                case 0x97:  
                            rx_atresponse(mypck);
                            break;
            }
            
            if( mypck->checksumcalc != mypck->checksum)
            {
                blink_error(1);
                XBEERXOK = 0;
            }
            else
            {
                XBEERXOK = 1;
                blink_ok(1);
            }
        }
    }
}

void rx_64bitaddress(xbee_pck *mypck)
{
    int i, k;
    uint8 serr=0, sdata=0;
    
    //FRAME ID
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
    mypck->frameid = sdata;
    
    //MSB ADDRESS (Most Significant Byte)
    for(i=0; i < 4; i++)
    {    
        while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(1);
        get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
        mypck->macmsb[i] = sdata;
    }                
    
    //LSB ADDRESS (Least Significant Byte)
    for(i=3; i >= 0; i--)
    {    
        while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(1);
        get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
        mypck->maclsb[i] = sdata;
    }
    
    //RSSI
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
    mypck->rssi = sdata;
    
    //OPTIONS
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
    mypck->options = sdata;
    
    //*************
    // DATA
    //*************
    k = mypck->length - 11;
    for(i=0; i < k; i++)
    {
        while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(1);
        get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
        mypck->rfdata[i] = sdata;
    }
    mypck->rflength = k;
    //++++++++++++++++++++++++++++++++++++++++++++++++++
    
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, 0);

    mypck->checksum = sdata;
    mypck->checksumcalc = 0xFF - mypck->checksumcalc;    
}

void rx_atresponse(xbee_pck *mypck)
{
    int i, k;
    uint8 serr=0, sdata=0;
    
    //********** FRAME ID **********//
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
    mypck->frameid = sdata;
    
    //MSB MAC (Most Significant Byte)
    for(i=0; i < 4; i++)
    {    
        while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(1);
        get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
        mypck->macmsb[i] = sdata;
    }                
    
    //LSB MAC (Least Significant Byte)
    for(i=3; i >= 0; i--)
    {    
        while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(1);
        get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
        mypck->maclsb[i] = sdata;
    }
    
    //********** NET ADDRESS **********//
    while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(1);
    get_from_uart(&serr, &sdata, 0);            
    mypck->netaddr[0] = sdata;
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, 0);
    mypck->netaddr[1] = sdata;
    
    //********** COMMAND **********//
    while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(1);
    get_from_uart(&serr, &sdata, 0);            
    mypck->command[0] = sdata;
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, 0);
    mypck->command[1] = sdata;
    
    //********** STATUS **********//
    while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(1);
    get_from_uart(&serr, &sdata, 0);            
    mypck->status = sdata;
    
    //********** DATA **********//
    k = mypck->length - 15;
    for(i=0; i < k; i++)
    {
        while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(1);
        get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
        mypck->commdata[i] = sdata;
    }
    mypck->rflength = k;
    //++++++++++++++++++++++++++++++++++++++++++++++++++
    
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, 0);

    mypck->checksum = sdata;
    mypck->checksumcalc = 0xFF - mypck->checksumcalc;
}

void rx_txstatus(xbee_pck *mypck)
{
    uint8 serr=0, sdata=0;
    
     //FRAME ID
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
    mypck->frameid = sdata;
    
    //STATUS
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, &(mypck->checksumcalc));
    mypck->status = sdata;
    //++++++++++++++++++++++++++++++++++++++++++++++++++
    
    while(XBEE_UART_GetRxBufferSize() == 0)
        CyDelayUs(1);
    get_from_uart(&serr, &sdata, 0);

    mypck->checksum = sdata;
    mypck->checksumcalc = 0xFF - mypck->checksumcalc; 
}

void get_from_uart(uint8 *serr, uint8 *sdata, uint8 *checksum)
{
    uint16 tempchar;
    
    tempchar = XBEE_UART_GetByte();
    *serr = (0xFF00 & tempchar) >> 8;
    *sdata = 0x00FF & tempchar;
    
    if( *sdata == 0x7D )
    {
        while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(1);
        tempchar = XBEE_UART_GetByte();
        *serr = (0xFF00 & tempchar) >> 8;
        *sdata = 0x00FF & tempchar;
        *sdata = *sdata^0x20;
    }
    if(checksum)
        *checksum = *checksum + *sdata;
}

void tx_status(uint8 checksum)
{
    uint8 frameid, status, rfchecksum;
    
    while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(10);
    frameid = XBEE_UART_GetByte();
    checksum = checksum+frameid;
    
    while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(10);
    status = XBEE_UART_GetByte();
    checksum = checksum+status;
    
    checksum = 0xFF - checksum;
    while(XBEE_UART_GetRxBufferSize() == 0)
            CyDelayUs(10);
    rfchecksum = XBEE_UART_GetByte();
    
    if( rfchecksum == checksum)
    {
        XBEETXSTATUS = status;
    }
}

int XBeeSendPacket()
{  
   uint8 *frame, *scaped_frame;
   int i, k; //variables enteras 
   uint8 checksumxbee, frame_size; //se declan mas variables para formar la trama del xbee
   
   checksumxbee = 0;
   
   frame_size = 15 + TXDataLength; //se le suma el lenght_data para calcular el tamaño del frame , 15 deconfiguracion + datos
   frame = (uint8*) malloc(sizeof(uint8)*frame_size);// RESERVAR LA MEMORIA DINAMICA
   
   //Frame init, Bite 1//
   frame[0] = xbee_settings[0];
   
   //Frame length Byte 2-3//
   frame[1] = 0x00;
   frame[2] = frame_size - 4; // MENOS CABECERA , 2 DE TAMAÑO DE PAQUETE Y CHECKSUM
   
   //ApiFrame,Byte 4//
   frame[3] = xbee_settings[1];
   checksumxbee += xbee_settings[1];
   
   //Frame ID for Response//
   frame[4] = xbee_settings[2]; 
   checksumxbee += xbee_settings[2];
   
   //Destination MAC Address//
   for(i = 5; i < 13; i++) //
   {
      frame[i] = broadcastAddress[i-5];
      checksumxbee += broadcastAddress[i-5];
   }
   
   //Setting options
   frame[13] = xbee_settings[3];
   checksumxbee += xbee_settings[3];
   
   //**Data**//
   for(i=14; i < 14+TXDataLength; i++)
   {
      frame[i] = XBeeTXbuffer[i-14];
      checksumxbee += XBeeTXbuffer[i-14];
   }
   
   //****//
   
   checksumxbee = 0xFF - checksumxbee;
   
   frame[14 + TXDataLength] = checksumxbee;
   
   scaped_frame = scape_frame(frame, &frame_size);
   
   if (scaped_frame != 0 )
   {
      free(frame);
      frame = scaped_frame;
   }

   for(k = 0; k < frame_size; k++)
   {
      XBEE_UART_PutChar(frame[k]);
      CyDelayUs(50);
   }
   free(frame);
   blink_ok(3);
   
   return 0;
}

uint8* scape_frame(uint8 *frame, uint8 *length)
{
   int count = 0, i , j;
   uint8 *escaped_frame;
   
   for (i=3; i < *length-1; i++)
   {
      if (frame[i] == ESCAPE1 || frame[i] == ESCAPE2 || frame[i] == ESCAPE3 || frame[i] == ESCAPE4) // se le hace una or a cada escape del frame
         ++count;
   }
   
   if (count > 0)
   {
      escaped_frame = (uint8*)malloc (sizeof(char)*(*length + count));
      escaped_frame[0] = frame[0];
      escaped_frame[1] = frame[1];
      escaped_frame[2] = frame[2];
      
      for(i=3, j=3; i < *length-1; i++, j++)
      {
         if( frame[i] == ESCAPE1 || frame[i] == ESCAPE2 || frame[i] == ESCAPE3 || frame[i] == ESCAPE4 )
         {
            escaped_frame[j] = 0x7D;
            ++j;
            escaped_frame[j] = frame[i]^0x20;
         }
         else
            escaped_frame[j] = frame[i];
      }
       escaped_frame[j] = frame[i];
      *length = *length+count;
      }
      if( !count )
         return 0;
      else
         return escaped_frame;

}
/* [] END OF FILE */
