/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#if !defined(__MYXBEE__)
#define __MYXBEE__

    #include <project.h>
    #include <stdio.h>
    #include <stdlib.h>
    #include <string.h>
    #include "definition.h"
    #include "blinkleds.h"
    #include "PLC_UART.h"
    
    typedef struct xbee_pck
    {
        //Regular Package Normalization
        uint16 length;
        uint8 apiid;
        uint8 frameid;
        uint8 macmsb[4];
        uint8 maclsb[4];
        uint8 netaddr[2];
        uint8 options;
        uint8 rfdata[100];
        uint8 rflength;
        uint8 checksum;
        uint8 checksumcalc;
        //RX additional parameters
        uint8 rssi;
        //AT Response
        uint8 command[2];
        uint8 status;
        uint8 commdata[100];
        struct xbee_pck *pck;
    } xbee_pck;
    
    extern xbee_pck *XBeeTX;
    xbee_pck *XBeeTX;
    extern xbee_pck *XBeeRX;
    xbee_pck *XBeeRX;

    void XBeePacketHandler();
    void rx_64bitaddress(xbee_pck *mypck);
    void rx_atresponse(xbee_pck *mypck);
    void rx_txstatus(xbee_pck *mypck);
    void get_from_uart(uint8 *serr, uint8 *sdata, uint8 *checksum);
    void tx_status(uint8 checksum);
    int XBeeSendPacket();
    uint8* scape_frame(uint8 *frame, uint8 *length);

#endif

/* [] END OF FILE */
